

local MAXPLAYERLEVEL = 80
local MAXDEBUFFSLOTS = 40

local LOCALIZEDCLASS, CLASS = UnitClass("player")
local LOCALIZEDRACE, RACE = UnitRace("player")
RACE = string.upper(RACE)
if RACE == "SCOURGE" then
	RACE = "UNDEAD"
elseif RACE == "NIGHT ELF" then
	RACE = "NIGHTELF"
elseif RACE == "BLOOD ELF" then
	RACE = "BLOODELF"
end
SpellFlashAddon.CLASS = CLASS
SpellFlashAddon.RACE = RACE
SpellFlashAddon.Castable = {}
SpellFlashAddon.Button = {}
SpellFlashAddon.ButtonMaxRank = {}
SpellFlashAddon.ButtonAll = {}
SpellFlashAddon.ButtonAllMaxRank = {}
Title_OPTIONS_LOCALIZATION_SpellFlashAddon = "SpellFlash "..GetAddOnMetadata("SpellFlash", "Version")
local FLASHSIZE = 2.4
local FLASHBRIGHTNESS = 1
local BUTTONSREGISTERED = nil
local TALENTSREGISTERED = nil
local TALENTRANK = {}
local TALENTTABPOINTS = {}
local IMMUNEIGNORELIST = {}
local CURRENTFORM = nil
local REALM = nil
local PLAYER = nil
local TIMER = {}
local LOADING = true


--[[
SpellFlashAddon.PRIEST
SpellFlashAddon.ROGUE
SpellFlashAddon.PALADIN
SpellFlashAddon.WARLOCK
SpellFlashAddon.WARRIOR
SpellFlashAddon.HUNTER
SpellFlashAddon.MAGE
SpellFlashAddon.SHAMAN
SpellFlashAddon.DRUID
SpellFlashAddon.DEATHKNIGHT
]]
SpellFlashAddon[CLASS] = {}

--[[
SpellFlashAddon.HUMAN
SpellFlashAddon.DWARF
SpellFlashAddon.GNOME
SpellFlashAddon.NIGHTELF
SpellFlashAddon.BLOODELF
SpellFlashAddon.ORC
SpellFlashAddon.UNDEAD
SpellFlashAddon.TAUREN
SpellFlashAddon.TROLL
SpellFlashAddon.DRAENEI
]]
SpellFlashAddon[RACE] = {}






function SpellFlashAddon.OnLoad()
	SpellFlashAddonFrame:Show()
	SpellFlashAddonFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
	SpellFlashAddonFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
	SpellFlashAddonFrame:RegisterEvent("ADDON_LOADED")
	SpellFlashAddonFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
	SpellFlashAddonFrame:RegisterEvent("PLAYER_ALIVE")
	SpellFlashAddonFrame:RegisterEvent("ACTIONBAR_HIDEGRID")
	SpellFlashAddonFrame:RegisterEvent("ACTIONBAR_SHOWGRID")
	SpellFlashAddonFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	SpellFlashAddonFrame:RegisterEvent("LEARNED_SPELL_IN_TAB")
	SpellFlashAddonFrame:RegisterEvent("CHARACTER_POINTS_CHANGED")
	SpellFlashAddonFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	SpellFlashAddonFrame:RegisterEvent("UPDATE_SHAPESHIFT_FORMS")
	SpellFlashAddonFrame:RegisterEvent("START_AUTOREPEAT_SPELL")
	SpellFlashAddonFrame:RegisterEvent("STOP_AUTOREPEAT_SPELL")
	SlashCmdList["SpellFlashAddon"] = SpellFlashAddon.SlashHandler
	SLASH_SpellFlashAddon1 = "/spellflash"
	SLASH_SpellFlashAddon2 = "/sflash"
	SLASH_SpellFlashAddon3 = "/sf"
end


function SpellFlashAddon.OnUpdate(arg1)
	SpellFlashAddon.TimerRunDown(arg1)
end


--Monitor combat status ourselves since the built in variables cannot be 
--trusted for some reason. 
function SpellFlashAddon.OnEvent(event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20)
	SpellFlashAddon.EventsDebug(event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20)
	if SpellFlashAddon[CLASS].OnEvent then
		SpellFlashAddon[CLASS].OnEvent(event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20)
	end

	if event == "PLAYER_REGEN_DISABLED" then
			
			SpellFlashAddon.Combat = 1
			
	elseif event == "PLAYER_REGEN_ENABLED" then
			
			SpellFlashAddon.Combat = nil
			
	elseif event == "START_AUTOREPEAT_SPELL" then
			
			SpellFlashAddon.AutoShoot = 1
			
	elseif event == "STOP_AUTOREPEAT_SPELL" then
			
			SpellFlashAddon.AutoShoot = nil
			
	elseif event == "ADDON_LOADED" then
			
			if arg1 == "SpellFlash" then
				SpellFlashAddon.CheckVariables()
			end
			
	elseif event == "PLAYER_ENTERING_WORLD" then
			
			SpellFlashAddon.SetTimer(2, "RegisterFunctions", nil, "InternalSpellFlashAddon", nil, SpellFlashAddon.RegisterFunctions)
			
	elseif event == "PLAYER_ALIVE" then
			
			SpellFlashAddon.RegisterFunctions(2)
			
	elseif event == "ACTIONBAR_SHOWGRID" then
			
			SpellFlashAddon.WipeButtons()
			
	elseif event == "ACTIONBAR_HIDEGRID" then
			
			SpellFlashAddon.WipeButtons()
			SpellFlashAddon.SetTimer(1, "RegisterButtons", nil, "InternalSpellFlashAddon", nil, SpellFlashAddon.RegisterButtons)
			
	elseif event == "LEARNED_SPELL_IN_TAB" then
			
			TALENTSREGISTERED = nil
			SpellFlashAddon.WipeButtons()
			SpellFlashAddon.SetTimer(1, "RegisterButtons", nil, "InternalSpellFlashAddon", nil, SpellFlashAddon.RegisterButtons)
			
	elseif event == "CHARACTER_POINTS_CHANGED" then
			
			TALENTSREGISTERED = nil
			SpellFlashAddon.WipeButtons()
			SpellFlashAddon.SetTimer(1, "RegisterButtons", nil, "InternalSpellFlashAddon", nil, SpellFlashAddon.RegisterButtons)
			
	elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then
			
			TALENTSREGISTERED = nil
			SpellFlashAddon.WipeButtons()
			SpellFlashAddon.SetTimer(1, "RegisterButtons", nil, "InternalSpellFlashAddon", nil, SpellFlashAddon.RegisterButtons)
			
	elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
			
			if arg3 == UnitGUID("player") then
				if arg12 == "IMMUNE" and UnitGUID("target") == arg6 and not UnitPlayerControlled("target") then
					if not SpellFlashAddonConfig.Immune[CLASS][arg10] then
						SpellFlashAddonConfig.Immune[CLASS][arg10] = {}
					end
					if not SpellFlashAddonConfig.Immune[CLASS][arg10][arg7] then
						SpellFlashAddonConfig.Immune[CLASS][arg10][arg7] = true
						SpellFlashAddon.msg(arg7.." is immune to "..arg10.."!")
						SpellFlashAddon.msg("This will be saved in the SpellFlash immunity database.")
					end
				end
			end
			
	elseif event == "UPDATE_SHAPESHIFT_FORMS" then
			
			SpellFlashAddon.RegisterForm()
			
	end

end





function SpellFlashAddon.SlashHandler(msg)
	msg = string.lower(""..msg.."")
	if (msg == "") or (msg == "version") or (msg == "options") or (msg == "help") or (msg == "status") or (msg == "show") then
		InterfaceOptionsFrame_OpenToCategory("SpellFlash")
	end
	if (msg == "reset") then
		SpellFlashAddonConfig[REALM][PLAYER] = nil
		SpellFlashAddon.debug_on = nil
		SpellFlashAddon.full_debug_mode = nil
		SpellFlashAddon.CheckVariables()
		SpellFlashAddon.SetSpam()
		SpellFlashAddon.LoadOptionsFrameSettings()
		SpellFlashAddon.msg("SpellFlash settings have been reset for "..UnitName("player"))
	end
	if (msg == "resetall") or (msg == "reset all") then
		SpellFlashAddonConfig = nil
		SpellFlashAddon.debug_on = nil
		SpellFlashAddon.full_debug_mode = nil
		SpellFlashAddon.CheckVariables()
		SpellFlashAddon.SetSpam()
		SpellFlashAddon.LoadOptionsFrameSettings()
		SpellFlashAddon.msg("SpellFlash settings have been reset for all players")
	end
	if (msg == "debug") then
		if SpellFlashAddon.debug_on then
			SpellFlashAddon.msg("SpellFlash debug is disabled")
			SpellFlashAddon.msg("Use (  /spellflash debug options  ) to see full list of options")
			SpellFlashAddonConfig[REALM][PLAYER].debug_on = nil
			SpellFlashAddon.debug_on = nil
		else
			SpellFlashAddon.msg("SpellFlash debug is enabled")
			SpellFlashAddonConfig[REALM][PLAYER].debug_on = true
			SpellFlashAddon.debug_on = true
		end
		SpellFlashAddon.LoadOptionsFrameSettings()
	end
	if (msg == "debug on") then
		SpellFlashAddonConfig[REALM][PLAYER].debug_on = true
		SpellFlashAddon.debug_on = true
		SpellFlashAddon.msg("SpellFlash debug is enabled")
		SpellFlashAddon.LoadOptionsFrameSettings()
	end
	if (msg == "debug off") then
		SpellFlashAddonConfig[REALM][PLAYER].debug_on = nil
		SpellFlashAddon.debug_on = nil
		SpellFlashAddon.msg("SpellFlash debug is disabled")
		SpellFlashAddon.msg("Use (  /spellflash debug options  ) to see full list of options")
		SpellFlashAddon.LoadOptionsFrameSettings()
	end
	if (msg == "debug mode") then
		if SpellFlashAddon.full_debug_mode then
			SpellFlashAddonConfig[REALM][PLAYER].full_debug_mode = nil
			SpellFlashAddon.full_debug_mode = nil
			SpellFlashAddon.msg("SpellFlash debug mode has been set to normal")
		else
			SpellFlashAddonConfig[REALM][PLAYER].full_debug_mode = true
			SpellFlashAddon.full_debug_mode = true
			SpellFlashAddon.msg("SpellFlash debug mode has been set to full")
		end
		SpellFlashAddon.LoadOptionsFrameSettings()
	end
	if (msg == "debug full on") or (msg == "debug mode full on") or (msg == "debug full") or (msg == "debug mode full") then
		SpellFlashAddonConfig[REALM][PLAYER].full_debug_mode = true
		SpellFlashAddon.full_debug_mode = true
		SpellFlashAddon.msg("SpellFlash debug mode has been set to full")
		SpellFlashAddon.LoadOptionsFrameSettings()
	end
	if (msg == "debug full off") or (msg == "debug mode full off") or (msg == "debug normal") or (msg == "debug normal on") or (msg == "debug mode normal") or (msg == "debug mode normal on") then
		SpellFlashAddonConfig[REALM][PLAYER].full_debug_mode = nil
		SpellFlashAddon.full_debug_mode = nil
		SpellFlashAddon.msg("SpellFlash debug mode has been set to normal")
		SpellFlashAddon.LoadOptionsFrameSettings()
	end
end


-- Registers the current Form or Stance
function SpellFlashAddon.RegisterForm()
	local n = GetShapeshiftForm()
	if not n or n == 0 then
		CURRENTFORM = nil
	else
		local _, form = GetShapeshiftFormInfo(n)
		CURRENTFORM = form
	end
	SpellFlashAddon.debug("Now in "..( CURRENTFORM or "Caster Form" ).."!")
end

function SpellFlashAddon.GiveForm()
	return CURRENTFORM
end

function SpellFlashAddon.isForm(form)
	if form then
		if form == CURRENTFORM then
			return true
		end
	elseif CURRENTFORM then
		return true
	end
	return false
end


function SpellFlashAddon.RegisterTalents()
	for Tab=1,GetNumTalentTabs() do
		TALENTTABPOINTS[Tab] = 0
		for Tal=1,GetNumTalents(Tab) do
			local name, icon, tier, column, rank = GetTalentInfo(Tab, Tal)
			TALENTRANK[name] = rank
			TALENTTABPOINTS[Tab] = TALENTTABPOINTS[Tab] + rank
		end
	end
	TALENTSREGISTERED = 1
end

function SpellFlashAddon.HasTalent(TalentName)
	if TalentName and TALENTRANK[TalentName] > 0 then
		return true
	end
	return false
end

function SpellFlashAddon.GetTalentRank(TalentName)
	if TalentName then
		return TALENTRANK[TalentName] or 0
	end
	return 0
end

-- This also works for pet spells.
function SpellFlashAddon.IsSpellKnown(SpellName)
	if SpellName and (GetSpellInfo(SpellName)) then
		return true
	end
	return false
end

-- This also works for pet spells.
function SpellFlashAddon.GetSpellRank(SpellName)
	if SpellName then
		local name, rank = GetSpellInfo(SpellName)
		if name then
			if rank ~= "" then
				local found, _, r = string.find(rank, "(%d+)")
				if found then
					return tonumber(r)
				end
			end
			return 1
		end
	end
	return 0
end

function SpellFlashAddon.OnCooldown(SpellName)
	if SpellName then
		local _, cool = GetSpellCooldown(SpellName)
		if cool ~= 0 then
			return true
		end
	end
	return false
end

function SpellFlashAddon.IsSpellAutocastOn(SpellName)
	if SpellName then
		local autocastable, autostate = GetSpellAutocast(SpellName)
		return autostate
	end
	return nil
end


function SpellFlashAddon.GetSpellCastTime(SpellName)
	if SpellName then
		local name, rank, icon, cost, isFunnel, powerType, castTime = GetSpellInfo(SpellName)
		return castTime or 0
	end
	return 0
end


function SpellFlashAddon.GetSpellCost(SpellName)
	local name, rank, icon, cost = GetSpellInfo(SpellName)
	return cost or 0
end

function SpellFlashAddon.RegisterFunctions(ButtonScanDelay)
	if LOADING then
		SpellFlashAddon.RegisterTalents()
		SpellFlashAddon.SetTimer(ButtonScanDelay, "RegisterButtons", nil, "InternalSpellFlashAddon", nil, SpellFlashAddon.RegisterButtons)
		SpellFlashAddon.LoadOptionsFrameSettings()
		SpellFlashAddon.RegisterForm()
		SpellFlashAddon.SetSpam()
		LOADING = nil
	end
end

function SpellFlashAddon.SetSpam()
	if not SpellFlashAddonConfig[REALM][PLAYER].spell_flashing_off and SpellFlashAddon[CLASS].SpamOn and SpellFlashAddon[CLASS].SpamOff then
		SpellFlashAddon[CLASS].SpamOn()
	end
end

function SpellFlashAddon.TimerRunDown(arg1)
	for fn,v in pairs(TIMER) do
		TIMER[fn]["Seconds"] = v["Seconds"] - arg1
		if TIMER[fn]["Seconds"] <= 0 then
			if type(v["Function"]) == "function" then
				v["Function"](
					v["FuncArg1"],
					v["FuncArg2"],
					v["FuncArg3"],
					v["FuncArg4"],
					v["FuncArg5"],
					v["FuncArg6"],
					v["FuncArg7"],
					v["FuncArg8"],
					v["FuncArg9"],
					v["FuncArg10"]
				)
			end
			if v["RepeatSeconds"] then
				SpellFlashAddon.SetTimer(
					v["RepeatSeconds"],
					v["Name"],
					v["Pre"],
					v["Tag"],
					v["RepeatSeconds"],
					v["Function"],
					v["FuncArg1"],
					v["FuncArg2"],
					v["FuncArg3"],
					v["FuncArg4"],
					v["FuncArg5"],
					v["FuncArg6"],
					v["FuncArg7"],
					v["FuncArg8"],
					v["FuncArg9"],
					v["FuncArg10"]
				)
			else
				TIMER[fn] = nil
			end
		end
	end
end


function SpellFlashAddon.gsub(OriginalString, FindIn1, ReplaceWith1, FindIn2, ReplaceWith2)
	if OriginalString and FindIn1 and ReplaceWith1 then
		OriginalString = string.gsub(OriginalString, FindIn1, ReplaceWith1)
		if FindIn2 and ReplaceWith2 then
			OriginalString = string.gsub(OriginalString, FindIn2, ReplaceWith2)
		end
		return OriginalString
	end
	return ""
end


function SpellFlashAddon.CheckVariables()
	if not PLAYER then
		PLAYER = UnitName("player")
		if not PLAYER then
			--Character name not available yet
			return false
		end
	end
	if not REALM then
		REALM = GetCVar("realmName")
	end
	if not SpellFlashAddonConfig then
		SpellFlashAddonConfig = {}
	end
	if not SpellFlashAddonConfig[REALM] then
		SpellFlashAddonConfig[REALM] = {}
	end
	if not SpellFlashAddonConfig[REALM][PLAYER] then
		SpellFlashAddonConfig[REALM][PLAYER] = {}
		SpellFlashAddonConfig[REALM][PLAYER].debug_on = nil
		SpellFlashAddonConfig[REALM][PLAYER].full_debug_mode = nil
		SpellFlashAddonConfig[REALM][PLAYER].auto_mob_immune_detection_off = nil
		SpellFlashAddonConfig[REALM][PLAYER].spell_flashing_off = nil
		SpellFlashAddonConfig[REALM][PLAYER].flash_size_percent = nil
		SpellFlashAddonConfig[REALM][PLAYER].flash_brightness_percent = nil
	end
	if not SpellFlashAddonConfig.Immune then
		SpellFlashAddonConfig.Immune = {}
	end
	if not SpellFlashAddonConfig.Immune[CLASS] then
		SpellFlashAddonConfig.Immune[CLASS] = {}
	end
	if not SpellFlashAddonConfig[REALM][PLAYER].ImmuneIgnore then
		SpellFlashAddonConfig[REALM][PLAYER].ImmuneIgnore = {}
	end
	if SpellFlashAddonConfig[REALM][PLAYER].debug_on then
		SpellFlashAddon.debug_on = true
	end
	if SpellFlashAddonConfig[REALM][PLAYER].full_debug_mode then
		SpellFlashAddon.full_debug_mode = true
	end
	if SpellFlashAddonConfig[REALM][PLAYER].flash_size_percent then
		FLASHSIZE = SpellFlashAddonConfig[REALM][PLAYER].flash_size_percent / 100
	end
	if SpellFlashAddonConfig[REALM][PLAYER].flash_brightness_percent then
		FLASHBRIGHTNESS = SpellFlashAddonConfig[REALM][PLAYER].flash_brightness_percent / 100
	end
end

function SpellFlashAddon.isImmune(SpellName, TargetName)
	if SpellFlashAddonConfig[REALM][PLAYER].auto_mob_immune_detection_off or UnitPlayerControlled("target") then
		return false
	end
	TargetName = TargetName or UnitName("target")
	if TargetName and TargetName ~= "" then
		if SpellFlashAddonConfig[REALM][PLAYER].ImmuneIgnore[TargetName] then
			return false
		elseif SpellName and SpellName ~= "" then
			if SpellFlashAddonConfig.Immune[CLASS][SpellName] and SpellFlashAddonConfig.Immune[CLASS][SpellName][TargetName] then
				return true
			end
		end
	end
	return false
end






function SpellFlashAddon.PopulateImmuneIgnoreListDropDownMenu()
	UIDropDownMenu_ClearAll(SpellFlashAddonOptionsFrame_ImmuneIgnoreList)
	UIDropDownMenu_Initialize(SpellFlashAddonOptionsFrame_ImmuneIgnoreList, SpellFlashAddon.MakeImmuneIgnoreListDropDownMenuButtons)
end

function SpellFlashAddon.MakeImmuneIgnoreListDropDownMenuButtons()
	local i = 0
	local info = {}
	for name,value in pairs(IMMUNEIGNORELIST) do
		info = {}
		info.text = name
		info.func = function()
			UIDropDownMenu_SetSelectedID(SpellFlashAddonOptionsFrame_ImmuneIgnoreList, this:GetID(), 0)
		end
		UIDropDownMenu_AddButton(info)
	end	
end

function SpellFlashAddon.AddToImmuneIgnoreList(TargetName)
	local name = SpellFlashAddonOptionsFrame_AddImmuneIgnore:GetText()
	if not name or name == "" then
		name = TargetName
	end
	if name and name ~= "" and not IMMUNEIGNORELIST[name] then
		local counter = 0
		for n,v in pairs(IMMUNEIGNORELIST) do
			counter = counter + 1
		end
		if counter < 32 then
			IMMUNEIGNORELIST[name] = true
			UIDropDownMenu_ClearAll(SpellFlashAddonOptionsFrame_ImmuneIgnoreList)
			SpellFlashAddon.PopulateImmuneIgnoreListDropDownMenu()
			SpellFlashAddonOptionsFrame_ImmuneIgnoreRemoveButton:Show()
		end
	end
	SpellFlashAddonOptionsFrame_AddImmuneIgnore:SetText("")
end

function SpellFlashAddon.RemoveFromImmuneIgnoreList()
	local name = UIDropDownMenu_GetText(SpellFlashAddonOptionsFrame_ImmuneIgnoreList)
	if name and name ~= "" then
		IMMUNEIGNORELIST[name] = nil
	end
	local found = nil
	for name,value in pairs(IMMUNEIGNORELIST) do
		found = 1
		break
	end
	if not found then
		SpellFlashAddonOptionsFrame_ImmuneIgnoreRemoveButton:Hide()
	end
	SpellFlashAddon.PopulateImmuneIgnoreListDropDownMenu()
end

function SpellFlashAddon.SpellFlashAddonOptionsFrame_OnLoad(panel)
	
	-- Set the name for the Category for the Panel
	panel.name = "SpellFlash"
	
	-- When the player clicks okay, run this function.
	panel.okay = function(self)
		SpellFlashAddon.SaveOptionsFrameSettings()
		SpellFlashAddon.LoadOptionsFrameSettings()
	end
	
	-- When the player clicks cancel, run this function.
	panel.cancel = function(self)
		SpellFlashAddon.LoadOptionsFrameSettings()
		SpellFlashAddon.ResetFlashSettings()
	end
	
	-- This is a function that is called when the player presses the Default Button.
	panel.default = function(self)
		SpellFlashAddon.LoadDefaultOptionsFrameSettings()
	end
	
	-- Add the panel to the Interface Options
	InterfaceOptions_AddCategory(panel)
	
end

function SpellFlashAddon.TestFlashSettings()
	local sizepercent = SpellFlashAddonOptionsFrame_FlashSizePercent:GetNumber()
	if sizepercent > 0 and sizepercent ~= 240 then
		FLASHSIZE = sizepercent / 100
	else
		FLASHSIZE = 2.4
	end
	local brightnesspercent = SpellFlashAddonOptionsFrame_FlashBrightnessPercent:GetNumber()
	if brightnesspercent > 0 and brightnesspercent < 100 then
		FLASHBRIGHTNESS = brightnesspercent / 100
	else
		FLASHBRIGHTNESS = 1
	end
end

function SpellFlashAddon.ResetFlashSettings()
	if SpellFlashAddonConfig[REALM][PLAYER].flash_size_percent then
		FLASHSIZE = SpellFlashAddonConfig[REALM][PLAYER].flash_size_percent / 100
	else
		FLASHSIZE = 2.4
	end
	if SpellFlashAddonConfig[REALM][PLAYER].flash_brightness_percent then
		FLASHBRIGHTNESS = SpellFlashAddonConfig[REALM][PLAYER].flash_brightness_percent / 100
	else
		FLASHBRIGHTNESS = 1
	end
end

function SpellFlashAddon.LoadDefaultOptionsFrameSettings()
	SpellFlashAddon.LoadOptionsFrameSettings()
	SpellFlashAddonOptionsFrame_SpellFlashing:SetChecked(true)
	SpellFlashAddonOptionsFrame_Debug:SetChecked(false)
	SpellFlashAddonOptionsFrame_FullDebug:SetChecked(false)
	SpellFlashAddonOptionsFrame_AutoMobImmunityDetection:SetChecked(true)
	SpellFlashAddonOptionsFrame_FlashSizePercent:SetNumber(240)
	FLASHSIZE = 2.4
	SpellFlashAddonOptionsFrame_FlashBrightnessPercent:SetNumber(100)
	FLASHBRIGHTNESS = 1
end

function SpellFlashAddon.LoadOptionsFrameSettings()
	IMMUNEIGNORELIST = {}
	local counter = 0
	for name,value in pairs(SpellFlashAddonConfig[REALM][PLAYER].ImmuneIgnore) do
		IMMUNEIGNORELIST[name] = value
		counter = counter + 1
	end
	if counter > 0 then
		SpellFlashAddonOptionsFrame_ImmuneIgnoreRemoveButton:Show()
	else
		SpellFlashAddonOptionsFrame_ImmuneIgnoreRemoveButton:Hide()
	end
	SpellFlashAddon.PopulateImmuneIgnoreListDropDownMenu()
	SpellFlashAddonOptionsFrame_AddImmuneIgnore:SetText("")
	if SpellFlashAddon.debug_on or SpellFlashAddon.full_debug_mode then
		SpellFlashAddonOptionsFrame_Debug:Show()
		SpellFlashAddonOptionsFrame_FullDebug:Show()
	end
	if SpellFlashAddon[CLASS].SpamOn and SpellFlashAddon[CLASS].SpamOff then
		SpellFlashAddonOptionsFrame_SpellFlashing:Show()
		SpellFlashAddonOptionsFrame_SpellFlashing:SetChecked(not SpellFlashAddonConfig[REALM][PLAYER].spell_flashing_off)
		SpellFlashAddonOptionsFrame_FlashSizePercentText:Show()
		SpellFlashAddonOptionsFrame_FlashSizePercentText2:Show()
		SpellFlashAddonOptionsFrame_FlashSizePercent:Show()
		SpellFlashAddonOptionsFrame_FlashSizePercent:SetNumber(SpellFlashAddonConfig[REALM][PLAYER].flash_size_percent or 240)
		SpellFlashAddonOptionsFrame_FlashBrightnessPercentText:Show()
		SpellFlashAddonOptionsFrame_FlashBrightnessPercentText2:Show()
		SpellFlashAddonOptionsFrame_FlashBrightnessPercent:Show()
		SpellFlashAddonOptionsFrame_FlashBrightnessPercent:SetNumber(SpellFlashAddonConfig[REALM][PLAYER].flash_brightness_percent or 100)
	end
	SpellFlashAddonOptionsFrame_Debug:SetChecked(SpellFlashAddon.debug_on)
	SpellFlashAddonOptionsFrame_FullDebug:SetChecked(SpellFlashAddon.full_debug_mode)
	SpellFlashAddonOptionsFrame_AutoMobImmunityDetection:SetChecked(not SpellFlashAddonConfig[REALM][PLAYER].auto_mob_immune_detection_off)
	SpellFlashAddonOptionsFrame_ClearImmuneDatabase:SetChecked(false)
end

function SpellFlashAddon.SaveOptionsFrameSettings()
	SpellFlashAddonConfig[REALM][PLAYER].ImmuneIgnore = {}
	for name,value in pairs(IMMUNEIGNORELIST) do
		SpellFlashAddonConfig[REALM][PLAYER].ImmuneIgnore[name] = value
	end
	SpellFlashAddonOptionsFrame_AddImmuneIgnore:SetText("")
	if SpellFlashAddonOptionsFrame_Debug:GetChecked() then
		SpellFlashAddonConfig[REALM][PLAYER].debug_on = true
		SpellFlashAddon.debug_on = true
	else
		SpellFlashAddonConfig[REALM][PLAYER].debug_on = nil
		SpellFlashAddon.debug_on = nil
	end
	if SpellFlashAddonOptionsFrame_FullDebug:GetChecked() then
		SpellFlashAddonConfig[REALM][PLAYER].full_debug_mode = true
		SpellFlashAddon.full_debug_mode = true
	else
		SpellFlashAddonConfig[REALM][PLAYER].full_debug_mode = nil
		SpellFlashAddon.full_debug_mode = nil
	end
	if SpellFlashAddonOptionsFrame_ClearImmuneDatabase:GetChecked() then
		SpellFlashAddonConfig.Immune = {}
		SpellFlashAddonConfig.Immune[CLASS] = {}
	end
	if SpellFlashAddonOptionsFrame_AutoMobImmunityDetection:GetChecked() then
		SpellFlashAddonConfig[REALM][PLAYER].auto_mob_immune_detection_off = nil
	else
		SpellFlashAddonConfig[REALM][PLAYER].auto_mob_immune_detection_off = true
	end
	if SpellFlashAddon[CLASS].SpamOn and SpellFlashAddon[CLASS].SpamOff then
		if SpellFlashAddonOptionsFrame_SpellFlashing:GetChecked() then
			SpellFlashAddonConfig[REALM][PLAYER].spell_flashing_off = nil
			SpellFlashAddon[CLASS].SpamOn()
		else
			SpellFlashAddonConfig[REALM][PLAYER].spell_flashing_off = true
			SpellFlashAddon[CLASS].SpamOff()
		end
		local sizepercent = SpellFlashAddonOptionsFrame_FlashSizePercent:GetNumber()
		if sizepercent > 0 and sizepercent ~= 240 then
			SpellFlashAddonConfig[REALM][PLAYER].flash_size_percent = sizepercent
			FLASHSIZE = sizepercent / 100
		else
			SpellFlashAddonConfig[REALM][PLAYER].flash_size_percent = nil
			FLASHSIZE = 2.4
		end
		local brightnesspercent = SpellFlashAddonOptionsFrame_FlashBrightnessPercent:GetNumber()
		if brightnesspercent > 0 and brightnesspercent < 100 then
			SpellFlashAddonConfig[REALM][PLAYER].flash_brightness_percent = brightnesspercent
			FLASHBRIGHTNESS = brightnesspercent / 100
		else
			SpellFlashAddonConfig[REALM][PLAYER].flash_brightness_percent = nil
			FLASHBRIGHTNESS = 1
		end
	end
end





--Will dump the value of msg to the default chat window
function SpellFlashAddon.msg(msg)
	if msg then
		DEFAULT_CHAT_FRAME:AddMessage(msg)
	end
end

-- show: 1=msg 0=block 2=FullDebugOnly nil=DebugOnly
local DebugCount = 0
function SpellFlashAddon.debug(msg, show)
	if ( SpellFlashAddon.debug_on or show == 1 ) and ( show ~= 2 or SpellFlashAddon.full_debug_mode ) and show ~= 0 and msg then
		if show == 1 then
			DEFAULT_CHAT_FRAME:AddMessage(msg)
		else
			DebugCount = DebugCount + 1
			DEFAULT_CHAT_FRAME:AddMessage("["..DebugCount.."]   "..msg)
		end
	end
end

local LastEventTime = 0
function SpellFlashAddon.EventsDebug(event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20)
	if SpellFlashAddon.debug_on and SpellFlashAddon.full_debug_mode and event and ( event ~= "COMBAT_LOG_EVENT_UNFILTERED" or arg3 == UnitGUID("player") or arg6 == UnitGUID("player") ) then
		local t = GetTime()
		SpellFlashAddon.debug("event:  "..event)
		SpellFlashAddon.debug("       Time:  "..t.."  -  "..LastEventTime.."  =  "..( t - LastEventTime ))
		LastEventTime = t
		for i=1,20 do
			if getglobal("arg"..i) and getglobal("arg"..i) ~= "" then
				SpellFlashAddon.debug("       arg"..i..":  "..getglobal("arg"..i))
			end
		end
	end
end







--Example: SpellFlashAddon.isClass("Paladin")
--The example above will return true if your target is a paladin.
--This function has been made so that english class names must be used with this function even if you are not using an english game client.
function SpellFlashAddon.isClass(class, unit)
	if class then
		local _, c = UnitClass(unit or "target")
		if string.lower(c) == string.lower(class) then
			return true
		end
	end
	return false
end
function SpellFlashAddon.isDruid(unit)
	return SpellFlashAddon.isClass("DRUID", unit)
end
function SpellFlashAddon.isHunter(unit)
	return SpellFlashAddon.isClass("HUNTER", unit) 
end
function SpellFlashAddon.isPaladin(unit)
	return SpellFlashAddon.isClass("PALADIN", unit) 
end
function SpellFlashAddon.isPriest(unit)
	return SpellFlashAddon.isClass("PRIEST", unit) 
end
function SpellFlashAddon.isMage(unit)
	return SpellFlashAddon.isClass("MAGE", unit) 
end
function SpellFlashAddon.isRogue(unit)
	return SpellFlashAddon.isClass("ROGUE", unit) 
end
function SpellFlashAddon.isShaman(unit)
	return SpellFlashAddon.isClass("SHAMAN", unit) 
end
function SpellFlashAddon.isWarlock(unit)
	return SpellFlashAddon.isClass("WARLOCK", unit) 
end
function SpellFlashAddon.isWarrior(unit)
	return SpellFlashAddon.isClass("WARRIOR", unit) 
end
function SpellFlashAddon.isDeathKnight(unit)
	return SpellFlashAddon.isClass("DEATHKNIGHT", unit) 
end





function SpellFlashAddon.isCasting(SpellName, SpellRank, unit)
	local spell, rank = UnitCastingInfo(unit or "player")
	if spell then
		if SpellName then
			if SpellName == spell then
				if SpellRank then
					local found, _, r = string.find(rank, "(%d+)")
					if found then
						rank = tonumber(r)
					else
						rank = 1
					end
					if SpellRank == rank then
						return true
					end
				else
					return true
				end
			end
		else
			return true
		end
	end
	return false
end


function SpellFlashAddon.isChanneling(SpellName, SpellRank, unit)
	local spell, rank = UnitChannelInfo(unit or "player")
	if spell then
		if SpellName then
			if SpellName == spell then
				if SpellRank then
					local found, _, r = string.find(rank, "(%d+)")
					if found then
						rank = tonumber(r)
					else
						rank = 1
					end
					if SpellRank == rank then
						return true
					end
				else
					return true
				end
			end
		else
			return true
		end
	end
	return false
end


function SpellFlashAddon.isCastingOrChanneling(SpellName, SpellRank, unit)
	if SpellFlashAddon.isCasting(SpellName, SpellRank, unit) or SpellFlashAddon.isChanneling(SpellName, SpellRank, unit) then
		return true
	end
	return false
end

--Since the PlayerFrame combat variable can be wrong, The same information
--can be accessed here.	Returns true if you are in combat
function SpellFlashAddon.inCombat()
	if SpellFlashAddon.Combat then
		return true
	end
	return false
end

-- Returns true if you are not in combat, and may use abilitys that can only be used out of combat
function SpellFlashAddon.notInCombat()
	if SpellFlashAddon.Combat then
		return false
	end
	return true
end

function SpellFlashAddon.usesMana(unit)
	if UnitPowerType(unit or "target") == 0 then
		return true
	end
	return false
end

function SpellFlashAddon.hasMana(unit)
	if UnitPowerType(unit or "target") == 0 and UnitMana(unit or "target") > 0 then
		return true
	end
	return false
end

function SpellFlashAddon.HealthPercent(unit)
	return ( UnitHealth(unit or "target") / UnitHealthMax(unit or "target") ) * 100
end

function SpellFlashAddon.HealthDamagePercent(unit)
	return 100 - SpellFlashAddon.HealthPercent(unit)
end

function SpellFlashAddon.HealthDamage(unit)
	return UnitHealthMax(unit or "target") - UnitHealth(unit or "target")
end

function SpellFlashAddon.ManaMissing(unit)
	return UnitManaMax(unit or "target") - UnitMana(unit or "target")
end

function SpellFlashAddon.ManaPercent(unit)
	return ( UnitMana(unit or "target") / UnitManaMax(unit or "target") ) * 100
end

--Convenience function that will tell if the target is attackable
function SpellFlashAddon.canAttack(unit)
	return UnitCanAttack("player", unit or "target")
end





















--returns true if all of the debuff slots are used
function SpellFlashAddon.AllDebuffSlotsUsed(unit)
	if UnitDebuff(unit or "target", MAXDEBUFFSLOTS) then
		return true
	end
	return false
end





function SpellFlashAddon.CancelBuff(SpellName, icon_texture)
	SpellName = SpellName or SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,icon_texture,nil,nil,nil,nil,1)
	if SpellName then
		CancelUnitBuff("player", SpellName)
	end
end




--Looks through all buffs looking for a match
function SpellFlashAddon.checkBuff(SpellName, unit, mine, applications, isExpirationTimeGreaterThan, Stealable, castable, icon_texture, SpellToolTipLineTwo, CheckRank, Type, giveapplications, giveindex, Debuff)
	if unit and ( unit == "MainHandSlot" or unit == "SecondaryHandSlot" ) then
		local slot = GetInventorySlotInfo(unit)
		if SpellName and GetInventoryItemLink("player", slot) then
			SpellFlashAddon_Tooltip:SetInventoryItem("player", slot)
			for i=1,SpellFlashAddon_Tooltip:NumLines() do
				local line = getglobal("SpellFlashAddon_TooltipTextLeft"..i):GetText()
				if line then
					if string.find(line, SpellName) then
						return true
					end
				end
			end
		end
		return false
	end
	if Debuff then
		unit = unit or "target"
		Debuff = "Debuff"
	else
		unit = unit or "player"
		Debuff = "Buff"
	end
	if castable and castable ~= 1 and castable ~= 0 then
		castable = 1
	end
	if SpellName and not giveindex and not mine and not SpellToolTipLineTwo and not Type and not Stealable then
		local name, rank, icon, count, debuffType, duration, expirationTime
		if type(SpellName) == "table" then
			for i,v in ipairs(SpellName) do
				name, rank, icon, count, debuffType, duration, expirationTime = getglobal("Unit"..Debuff)(unit, v, castable)
				if name then
					break
				end
			end
		else
			name, rank, icon, count, debuffType, duration, expirationTime = getglobal("Unit"..Debuff)(unit, SpellName, castable)
		end
		if name then
			if CheckRank then
				local found, _, r = string.find(rank, "(%d+)")
				if found then
					rank = tonumber(r)
				else
					rank = 1
				end
				if rank > CheckRank then
					if giveapplications then
						if count == 0 then
							return 1
						end
						return count
					end
					return true
				end
			end
			if ( not applications or applications == count ) and ( not isExpirationTimeGreaterThan or expirationTime > isExpirationTimeGreaterThan ) and ( not CheckRank or rank >= CheckRank ) then
				if giveapplications then
					if count == 0 then
						return 1
					end
					return count
				end
				return true
			end
		end
	else
		local c = 1
		while getglobal("Unit"..Debuff)(unit, c) do
			local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable = getglobal("Unit"..Debuff)(unit, c, castable)
			if name then
				if SpellName then
					if type(SpellName) == "table" then
						for i,v in ipairs(SpellName) do
							if v == name then
								SpellName = nil
								break
							end
						end
					elseif SpellName == name then
						SpellName = nil
					end
				end
				if not SpellName and ( not icon_texture or string.find(icon, icon_texture) ) and ( not mine or unitCaster == "player" ) then
					if SpellToolTipLineTwo then
						SpellFlashAddon_Tooltip:getglobal("SetUnit"..Debuff)(unit, c)
						local debuffline2 = SpellFlashAddon_TooltipTextLeft2:GetText() or ""
						if string.find(debuffline2, SpellToolTipLineTwo) then
							SpellToolTipLineTwo = nil
						end
					end
					if not SpellToolTipLineTwo then
						if CheckRank then
							local found, _, r = string.find(rank, "(%d+)")
							if found then
								rank = tonumber(r)
							else
								rank = 1
							end
							if rank > CheckRank then
								if giveapplications then
									if count == 0 then
										return 1
									end
									return count
								elseif giveindex then
									return c
								end
								return true
							end
						end
						if ( not Type or string.lower(Type) == string.lower(debuffType) ) and ( not Stealable or isStealable ) and ( not applications or applications == count ) and ( not isExpirationTimeGreaterThan or expirationTime > isExpirationTimeGreaterThan ) and ( not CheckRank or rank >= CheckRank ) then
							if giveapplications then
								if count == 0 then
									return 1
								end
								return count
							elseif giveindex then
								return c
							end
							return true
						end
					end
				end
			end
			c = c + 1
		end
	end
	if giveapplications then
		return 0
	elseif giveindex then
		return nil
	end
	return false
end


--Looks through all debuffs looking for a match
function SpellFlashAddon.checkDebuff(SpellName, unit, mine, applications, isExpirationTimeGreaterThan, Stealable, dispelable, icon_texture, SpellToolTipLineTwo, CheckRank, Type, giveapplications, giveindex)
	return SpellFlashAddon.checkBuff(SpellName, unit, mine, applications, isExpirationTimeGreaterThan, Stealable, dispelable, icon_texture, SpellToolTipLineTwo, CheckRank, Type, giveapplications, giveindex, 1)
end


--Loops through all buffs looking for a match and returns the index number
function SpellFlashAddon.GiveBuffIndex(SpellName, unit, mine, applications, isExpirationTimeGreaterThan, Stealable, castable, icon_texture, SpellToolTipLineTwo, CheckRank, Type)
	return SpellFlashAddon.checkBuff(SpellName, unit, mine, applications, isExpirationTimeGreaterThan, Stealable, castable, icon_texture, SpellToolTipLineTwo, CheckRank, Type, nil, 1)
end

--Loops through all buffs looking for a match and returns the index number
function SpellFlashAddon.GiveDebuffIndex(SpellName, unit, mine, applications, isExpirationTimeGreaterThan, Stealable, dispelable, icon_texture, SpellToolTipLineTwo, CheckRank, Type)
	return SpellFlashAddon.checkBuff(SpellName, unit, mine, applications, isExpirationTimeGreaterThan, Stealable, dispelable, icon_texture, SpellToolTipLineTwo, CheckRank, Type, nil, 1, 1)
end





function SpellFlashAddon.checkMainHandItemBuff(SpellName)
	return SpellFlashAddon.checkBuff(SpellName, "MainHandSlot")
end

function SpellFlashAddon.checkOffHandItemBuff(SpellName)
	return SpellFlashAddon.checkBuff(SpellName, "SecondaryHandSlot")
end

function SpellFlashAddon.checkHandItemBuff(SpellName, hand)
	if hand then
		hand = string.lower(""..hand.."")
		if hand == "main" or hand == "1" or hand == "mainhandslot" then
			return SpellFlashAddon.checkBuff(SpellName, "MainHandSlot")
		elseif hand == "off" or hand == "2" or hand == "secondaryhandslot" then
			return SpellFlashAddon.checkBuff(SpellName, "SecondaryHandSlot")
		end
		SpellFlashAddon.debug("Valid arguments for SpellFlashAddon.checkHandItemBuff() are: \"main\", \"off\", 1, 2 and nil")
	elseif SpellFlashAddon.checkBuff(SpellName, "MainHandSlot") or SpellFlashAddon.checkBuff(SpellName, "SecondaryHandSlot") then
		return true
	end
	return false
end


-- Returns the amount of times a debuff is stacked on the target, and returns 0 if the debuff is not on the target.
function SpellFlashAddon.GetDebuffStack(SpellName, unit, dispelable, icon_texture, SpellToolTipLineTwo, CheckRank, Type)
	return SpellFlashAddon.checkBuff(SpellName, unit, nil, nil, nil, nil, dispelable, icon_texture, SpellToolTipLineTwo, CheckRank, Type, 1, nil, 1)
end

-- Returns the amount of times a buff is stacked on the target, and returns 0 if the buff is not on the target.
function SpellFlashAddon.GetBuffStack(SpellName, unit, castable, icon_texture, SpellToolTipLineTwo, CheckRank, Type)
	return SpellFlashAddon.checkBuff(SpellName, unit, nil, nil, nil, nil, castable, icon_texture, SpellToolTipLineTwo, CheckRank, Type, 1)
end




function SpellFlashAddon.isBreakOnDamageCC(unit, dispelable)
	if SpellFlashAddon.checkDebuff((GetSpellInfo(118))--[["Polymorph"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(2637))--[["Hibernate"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(9484))--[["Shackle Undead"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(6770))--[["Sap"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(6358))--[["Seduction"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(19503))--[["Scatter Shot"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(1499))--[["Freezing Trap"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(51514))--[["Hex"]],unit,nil,nil,nil,nil,dispelable)
	or (
			SpellFlashAddon.checkDebuff((GetSpellInfo(19386))--[["Wyvern Sting"]],unit,nil,nil,nil,nil,dispelable)
			and
			SpellFlashAddon.checkDebuff((GetSpellInfo(19386))--[["Wyvern Sting"]],unit,nil,nil,nil,nil,dispelable,nil,SpellFlashAddon.LOCALIZATION["Asleep."])
		)
	then
		return true
	end
	return false
end


--all forms of fear and movement impairing affects are not included since they do not prevent the target from being damaged
--Mind Control is no longer included as a CC in this function
function SpellFlashAddon.isNoDamageCC(unit, dispelable)
	if SpellFlashAddon.isBreakOnDamageCC(unit, dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(710))--[["Banish"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(33786))--[["Cyclone"]],unit,nil,nil,nil,nil,dispelable)
	-- or SpellFlashAddon.checkDebuff((GetSpellInfo(605))--[["Mind Control"]],unit,nil,nil,nil,nil,dispelable)
	then
		return true
	end
	return false
end


--movement impairing affects are not included since the target could still attack
function SpellFlashAddon.isCrowedControlled(unit, dispelable)
	if SpellFlashAddon.isNoDamageCC(unit, dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(5782))--[["Fear"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(5484))--[["Howl of Terror"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(8122))--[["Psychic Scream"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(1513))--[["Scare Beast"]],unit,nil,nil,nil,nil,dispelable)
	then
		return true
	end
	return false
end


--movement impairing affects are not included since the target could still attack
function SpellFlashAddon.isFeared(unit, dispelable)
	if SpellFlashAddon.checkDebuff((GetSpellInfo(5782))--[["Fear"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(5484))--[["Howl of Terror"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(8122))--[["Psychic Scream"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(1513))--[["Scare Beast"]],unit,nil,nil,nil,nil,dispelable)
	then
		return true
	end
	return false
end


function SpellFlashAddon.isRooted(unit, dispelable)
	if SpellFlashAddon.checkDebuff((GetSpellInfo(339))--[["Entangling Roots"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(122))--[["Frost Nova"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(45524))--[["Chains of Ice"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(16979))--[["Feral Charge - Bear"]],unit,nil,nil,nil,nil,dispelable)
	then
		return true
	end
	return false
end


function SpellFlashAddon.isMovementImpaired(unit, dispelable)
	if SpellFlashAddon.isRooted(unit, dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(2974))--[["Wing Clip"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(5116))--[["Concussive Shot"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(13809))--[["Frost Trap"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(116))--[["Frostbolt"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(120))--[["Cone of Cold"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(11113))--[["Blast Wave"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(31589))--[["Slow"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(15407))--[["Mind Flay"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(3408))--[["Crippling Poison"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(26679))--[["Deadly Throw"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(8056))--[["Frost Shock"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(2484))--[["Earthbind Totem"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(18223))--[["Curse of Exhaustion"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(1715))--[["Hamstring"]],unit,nil,nil,nil,nil,dispelable)
	or SpellFlashAddon.checkDebuff((GetSpellInfo(12323))--[["Piercing Howl"]],unit,nil,nil,nil,nil,dispelable)
	then
		return true
	end
	return false
end















function SpellFlashAddon.isUnit(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	unit = unit or "target"
	if UnitExists(unit) then
		if not enemy or ( UnitCanAttack("player", unit) and ( UnitHealth(unit) > 0 or UnitExists(unit.."target") or UnitAffectingCombat(unit) or ( UnitIsPlayer(unit) and SpellFlashAddon.isClass("Hunter", unit) ) ) ) then
			if not active or ((UnitAffectingCombat(unit) or UnitExists(unit.."target") or UnitHealth(unit) < UnitHealthMax(unit) or UnitIsPlayer(unit) or (UnitIsEnemy("player", unit) and CheckInteractDistance(unit, 3))) and not SpellFlashAddon.isNoDamageCC(unit)) then
				if not player or UnitIsPlayer(unit) then
					if not mob or (not UnitPlayerControlled(unit) and (enemy or UnitExists(unit))) then
						if not givesxp or ((enemy or (UnitCanAttack("player", unit) and (UnitHealth(unit) > 0 or UnitExists(unit.."target") or UnitAffectingCombat(unit) or (UnitIsPlayer(unit) and SpellFlashAddon.isClass("Hunter", unit))))) and not UnitIsTrivial(unit) and UnitFactionGroup(unit) ~= UnitFactionGroup("player") and not UnitIsPet(unit) and (UnitIsPlayer(unit) or not UnitIsTapped(unit) or UnitIsTappedByPlayer(unit))) then
							if not lessthenhealthpercent or SpellFlashAddon.HealthPercent(unit) <= lessthenhealthpercent then
								if not unithasnotarget or not UnitExists(unit.."target") then
									if not unitistargetingyou or UnitIsUnit(unit.."target", "player") then
										if not unitistargetingyourfriend or (not UnitIsUnit(unit.."target", "player") and UnitIsFriend("player", unit.."target")) then
											if not unitistargetingselforitsfriend or UnitCanAttack("player", unit.."target") then
												if not isboss or UnitClassification(unit) == "worldboss" then
													return true
												end
											end
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
	return false
end

	


function SpellFlashAddon.isEnemy(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
end

function SpellFlashAddon.isActiveEnemy(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, 1, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
end

function SpellFlashAddon.isActiveEnemyThatGivesXP(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, 1, player, mob, 1, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
end

function SpellFlashAddon.isBoss(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, 1)
end

function SpellFlashAddon.isEnemyBoss(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, 1)
end

function SpellFlashAddon.isActiveEnemyBoss(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, 1, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, 1)
end

function SpellFlashAddon.GivesXP(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, active, player, mob, 1, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
end

function SpellFlashAddon.isEnemyPlayer(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, active, 1, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
end

function SpellFlashAddon.isEnemyMob(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, active, player, 1, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
end

function SpellFlashAddon.isActiveEnemyMob(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, 1, player, 1, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
end

function SpellFlashAddon.isDieingEnemy(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, active, player, mob, givesxp, 20, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
end

function SpellFlashAddon.isDieingEnemyWithNoTarget(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, active, player, mob, givesxp, 20, 1, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
end

function SpellFlashAddon.isEnemyTargetingYou(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, 1, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
end

function SpellFlashAddon.isActiveEnemyTargetingYou(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, 1, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, 1, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
end

function SpellFlashAddon.isEnemyBossTargetingYou(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, 1, unitistargetingyourfriend, unitistargetingselforitsfriend, 1)
end

function SpellFlashAddon.isEnemyTargetingFriendButNotYou(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, 1, unitistargetingselforitsfriend, isboss)
end

function SpellFlashAddon.isEnemyTargetingEnemy(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	return SpellFlashAddon.isUnit(unit, 1, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, 1)
end

function SpellFlashAddon.isFriendTargetingEnemy(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	if UnitIsFriend("player", unit or "target") and SpellFlashAddon.isEnemy(unit or "target".."target", enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss) then
		return true
	end
	return false
end

function SpellFlashAddon.isFriendTargetingActiveEnemy(unit, enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss)
	if UnitIsFriend("player", unit or "target") and SpellFlashAddon.isActiveEnemy(unit or "target".."target", enemy, active, player, mob, givesxp, lessthenhealthpercent, unithasnotarget, unitistargetingyou, unitistargetingyourfriend, unitistargetingselforitsfriend, isboss) then
		return true
	end
	return false
end







-- checks to see if a fist weapon is equipped in the main hand
function SpellFlashAddon.isHandFistWeapon(offhand)
	if offhand then
		offhand = "SecondaryHandSlot"
	end
	local slot = GetInventorySlotInfo(offhand or "MainHandSlot")
	if SpellFlashAddon.GetItemSubType(GetInventoryItemLink("player", slot)) == (GetSpellInfo(15590))--[["Fist Weapons"]] then
		if GetInventoryItemBroken("player", slot) then
			--SpellFlashAddon.debug("Your fist weapon in the main hand is broken.")
			return false
		end
		--SpellFlashAddon.debug("You have a fist weapon equipped in the main hand.", 2)
		return true
	end
	--SpellFlashAddon.debug("You do not have a fist weapon equipped in the main hand.", 2)
	return false
end

-- checks to see if a stave is equipped in the main hand
function SpellFlashAddon.isHandStave(offhand)
	if offhand then
		offhand = "SecondaryHandSlot"
	end
	local slot = GetInventorySlotInfo(offhand or "MainHandSlot")
	if SpellFlashAddon.GetItemSubType(GetInventoryItemLink("player", slot)) == (GetSpellInfo(227))--[["Staves"]] then
		if GetInventoryItemBroken("player", slot) then
			--SpellFlashAddon.debug("Your stave in the main hand is broken.")
			return false
		end
		--SpellFlashAddon.debug("You have a stave equipped in the main hand.", 2)
		return true
	end
	--SpellFlashAddon.debug("You do not have a stave equipped.", 2)
	return false
end

-- checks to see if a polearm is equipped in the main hand
function SpellFlashAddon.isHandPolearm(offhand)
	if offhand then
		offhand = "SecondaryHandSlot"
	end
	local slot = GetInventorySlotInfo(offhand or "MainHandSlot")
	if SpellFlashAddon.GetItemSubType(GetInventoryItemLink("player", slot)) == (GetSpellInfo(200))--[["Polearms"]] then
		if GetInventoryItemBroken("player", slot) then
			--SpellFlashAddon.debug("Your polearm in the main hand is broken.")
			return false
		end
		--SpellFlashAddon.debug("You have a polearm equipped in the main hand.", 2)
		return true
	end
	--SpellFlashAddon.debug("You do not have a polearm equipped.", 2)
	return false
end

-- checks to see if a one or two handed mace is equipped in the main hand
function SpellFlashAddon.isHandMace(offhand)
	if offhand then
		offhand = "SecondaryHandSlot"
	end
	local slot = GetInventorySlotInfo(offhand or "MainHandSlot")
	local itemType = SpellFlashAddon.GetItemSubType(GetInventoryItemLink("player", slot))
	if itemType == (GetSpellInfo(198))--[["One-Handed Maces"]] or itemType == (GetSpellInfo(199))--[["Two-Handed Maces"]] then
		if GetInventoryItemBroken("player", slot) then
			--SpellFlashAddon.debug("Your mace in the main hand is broken.")
			return false
		end
		--SpellFlashAddon.debug("You have a mace equipped in the main hand.", 2)
		return true
	end
	--SpellFlashAddon.debug("You do not have a mace equipped in the main hand.", 2)
	return false
end

-- checks to see if a one or two handed axe is equipped in the main hand
function SpellFlashAddon.isHandAxe(offhand)
	if offhand then
		offhand = "SecondaryHandSlot"
	end
	local slot = GetInventorySlotInfo(offhand or "MainHandSlot")
	local itemType = SpellFlashAddon.GetItemSubType(GetInventoryItemLink("player", slot))
	if itemType == (GetSpellInfo(196))--[["One-Handed Axes"]] or itemType == (GetSpellInfo(197))--[["Two-Handed Axes"]] then
		if GetInventoryItemBroken("player", slot) then
			--SpellFlashAddon.debug("Your axe in the main hand is broken.")
			return false
		end
		--SpellFlashAddon.debug("You have a axe equipped in the main hand.", 2)
		return true
	end
	--SpellFlashAddon.debug("You do not have a axe equipped in the main hand.", 2)
	return false
end

-- checks to see if a one or two handed sword is equipped in the main hand
function SpellFlashAddon.isHandSword(offhand)
	if offhand then
		offhand = "SecondaryHandSlot"
	end
	local slot = GetInventorySlotInfo(offhand or "MainHandSlot")
	local itemType = SpellFlashAddon.GetItemSubType(GetInventoryItemLink("player", slot))
	if itemType == (GetSpellInfo(201))--[["One-Handed Swords"]] or itemType == (GetSpellInfo(202))--[["Two-Handed Swords"]] then
		if GetInventoryItemBroken("player", slot) then
			--SpellFlashAddon.debug("Your sword in the main hand is broken.")
			return false
		end
		--SpellFlashAddon.debug("You have a sword equipped in the main hand.", 2)
		return true
	end
	--SpellFlashAddon.debug("You do not have a sword equipped in the main hand.", 2)
	return false
end

-- checks to see if a dagger is equipped in the main hand
function SpellFlashAddon.isHandDagger(offhand)
	if offhand then
		offhand = "SecondaryHandSlot"
	end
	local slot = GetInventorySlotInfo(offhand or "MainHandSlot")
	if SpellFlashAddon.GetItemSubType(GetInventoryItemLink("player", slot)) == (GetSpellInfo(1180))--[["Daggers"]] then
		if GetInventoryItemBroken("player", slot) then
			--SpellFlashAddon.debug("Your dagger in the main hand is broken.")
			return false
		end
		--SpellFlashAddon.debug("You have a dagger equipped in the main hand.", 2)
		return true
	end
	--SpellFlashAddon.debug("You do not have a dagger equipped in the main hand.", 2)
	return false
end

-- checks to see if a dagger is equipped in the main hand
function SpellFlashAddon.isShieldEquipped()
	local slot = GetInventorySlotInfo("SecondaryHandSlot")
	if SpellFlashAddon.GetItemSubType(GetInventoryItemLink("player", slot)) == SpellFlashAddon.LOCALIZATION["Shields"] then
		if GetInventoryItemBroken("player", slot) then
			--SpellFlashAddon.debug("Your dagger in the main hand is broken.")
			return false
		end
		--SpellFlashAddon.debug("You have a dagger equipped in the main hand.", 2)
		return true
	end
	--SpellFlashAddon.debug("You do not have a dagger equipped in the main hand.", 2)
	return false
end


-- checks to see if a main hand item is equipped
function SpellFlashAddon.isHandEquipped(offhand)
	if offhand then
		offhand = "SecondaryHandSlot"
	end
	local slot = GetInventorySlotInfo(offhand or "MainHandSlot")
	if (GetInventoryItemLink("player", slot)) then
		if GetInventoryItemBroken("player", slot) then
			--SpellFlashAddon.debug("Your main hand item is broken.")
			return false
		end
		--SpellFlashAddon.debug("You have a main hand item equipped.", 2)
		return true
	end
	--SpellFlashAddon.debug("You do not have a main hand item equipped.", 2)
	return false
end


-- This is a test function
function SpellFlashAddon.ShowMainHandType()
	if (GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot"))) then
		SpellFlashAddon.msg(SpellFlashAddon.GetItemSubType(GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot"))))
	else
		SpellFlashAddon.msg("You do not have a main hand item equipped.")
	end
end

-- This is a test function
function SpellFlashAddon.ShowOffHandType()
	if (GetInventoryItemLink("player",GetInventorySlotInfo("SecondaryHandSlot"))) then
		SpellFlashAddon.msg(SpellFlashAddon.GetItemSubType(GetInventoryItemLink("player",GetInventorySlotInfo("SecondaryHandSlot"))))
	else
		SpellFlashAddon.msg("You do not have a off hand item equipped.")
	end
end






function SpellFlashAddon.isTrinketByNameReady(name, find, id)
	if name or id then
		local n = SpellFlashAddon.GiveTrinketSlotNumberByName(name, find, id)
		if n then
			local s, d, e = GetInventoryItemCooldown("player", n)
			if e == 1 then
				if s == 0 then
					return true
				elseif name then
					SpellFlashAddon.debug("Trinket: ( "..name.." ) in slot#"..n.." is on cooldown!")
				else
					SpellFlashAddon.debug("Trinket: ( "..SpellFlashAddon.GiveItemNameFromItemLink(GetInventoryItemLink("player", n)).." ) in slot#"..n.." is on cooldown!")
				end
			elseif name then
				SpellFlashAddon.debug("Trinket: ( "..name.." ) in slot#"..n.." has nothing to use!")
			else
				SpellFlashAddon.debug("Trinket: ( "..SpellFlashAddon.GiveItemNameFromItemLink(GetInventoryItemLink("player", n)).." ) in slot#"..n.." has nothing to use!")
			end
		end
	end
	return false
end
function SpellFlashAddon.isTrinketByItemIDReady(id, name, find)
	return SpellFlashAddon.isTrinketByNameReady(name, find, id)
end


function SpellFlashAddon.isTrinketByNameEquipped(name, find, id)
	if SpellFlashAddon.GiveTrinketSlotNumberByName(name, find, id) then
		return true
	end
	return false
end
function SpellFlashAddon.isTrinketByItemIDEquipped(id, name, find)
	return SpellFlashAddon.isTrinketByNameEquipped(name, find, id)
end


function SpellFlashAddon.GiveTrinketSlotNumberByName(name, find, id)
	if name or id then
		id = SpellFlashAddon.GiveItemIDFromItemLink(id) or id
		for i=0,1 do
			local slot = GetInventorySlotInfo("Trinket"..i.."Slot")
			local link = GetInventoryItemLink("player", slot)
			local n, d = SpellFlashAddon.DecodeItemLink(link)
			if id then
				if d and (d == id or ""..d == id or "item:"..d..":0:0:0" == id or "item:"..d == id or d..":0:0:0" == id) then
					return slot
				end
			elseif name then
				if n then
					if (find and string.find(n, name)) or n == name then
						return slot
					end
				end
			end
		end
		if name then
			SpellFlashAddon.debug("Trinket: ( "..name.." ) is not equipped!")
		else
			local N = SpellFlashAddon.GetItemName(id)
			if N then
				SpellFlashAddon.debug("Trinket: ( "..N.." ) is not equipped!")
			end
		end
	else
		SpellFlashAddon.debug("Trinket name and id not given!")
	end
	return nil
end
function SpellFlashAddon.GiveTrinketSlotNumberByItemID(id, name, find)
	return SpellFlashAddon.GiveTrinketSlotNumberByName(name, find, id)
end






function SpellFlashAddon.isItemByNameEquipped(name, find, id)
	if SpellFlashAddon.GiveEquippedItemSlotNumberByName(name, find, id) then
		return true
	end
	return false
end
function SpellFlashAddon.isItemByItemIDEquipped(id, name, find)
	return SpellFlashAddon.isItemByNameEquipped(name, find, id)
end


function SpellFlashAddon.GiveEquippedItemSlotNumberByName(name, find, id)
	if name or id then
		local id = SpellFlashAddon.GiveItemIDFromItemLink(id) or id
		for slot=0,19 do
			local link = GetInventoryItemLink("player", slot)
			local n, d = SpellFlashAddon.DecodeItemLink(link)
			if id then
				if d and (d == id or ""..d == id or "item:"..d..":0:0:0" == id or "item:"..d == id or d..":0:0:0" == id) then
					return slot
				end
			elseif name then
				if n then
					if (find and string.find(n, name)) or n == name then
						return slot
					end
				end
			end
		end
		if name then
			SpellFlashAddon.debug("Item: ( "..name.." ) is not equipped!")
		else
			local N = SpellFlashAddon.GetItemName(id)
			if N then
				SpellFlashAddon.debug("Item: ( "..N.." ) is not equipped!")
			end
		end
	else
		SpellFlashAddon.debug("Equipped Item name and id not given!")
	end
	return nil
end
function SpellFlashAddon.GiveEquippedItemSlotNumberByItemID(id, name, find)
	return SpellFlashAddon.GiveEquippedItemSlotNumberByName(name, find, id)
end


function SpellFlashAddon.GiveContainerItemCount(name, find, id)
	id = SpellFlashAddon.GiveItemIDFromItemLink(id) or id
	local count = 0
	for b=0,NUM_BAG_FRAMES do
		local bagslots = GetContainerNumSlots(b)
		if bagslots and bagslots > 0 then
			for s=1,bagslots do
				local n, d = SpellFlashAddon.DecodeItemLink(GetContainerItemLink(b, s))
				if id then
					if d and d == id then
						local c = GetContainerItemInfo(b, s)
						count = count + c
					end
				elseif name and n and ( ( find and string.find(n, name) ) or n == name ) then
					local c = GetContainerItemInfo(b, s)
					count = count + c
				end
			end
		end
	end
	return count
end
function SpellFlashAddon.GiveContainerItemCountByItemID(id, name, find)
	return SpellFlashAddon.GiveContainerItemCount(name, find, id)
end


function SpellFlashAddon.DecodeItemLink(link)
	if link then
		local found, _, id, name = string.find(link, "item:(%d+):.*%[(.*)%]")
		if found then
			id = tonumber(id)
			return name, id
		end
	end
	return nil
end

function SpellFlashAddon.GiveItemNameFromItemLink(link)
	return (SpellFlashAddon.DecodeItemLink(link))
end

function SpellFlashAddon.GiveItemIDFromItemLink(link)
	local _, id = SpellFlashAddon.DecodeItemLink(link)
	return id
end



function SpellFlashAddon.GetItemSubType(id)
	if id then
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType = GetItemInfo(id)
		return itemSubType
	end
	return nil
end

function SpellFlashAddon.GetItemName(id)
	if id then
		return (GetItemInfo(id))
	end
	return nil
end




function SpellFlashAddon.MakeMacro(name, macro, percharacter, macroicontecture, iconindex, replace, show, nocreate, replacemacroindex, replacemacroname)
	local globalorlocal = "global"
	local macroindex = replacemacroindex or GetMacroIndexByName(name) or 0
	local macroiconindex = iconindex or 1
	if not iconindex and macroicontecture then
		local mi = SpellFlashAddon.GiveMacroIconIndex(macroicontecture)
		if mi then
			macroiconindex = mi
		end
	end
	if not replacemacroindex and not (macroindex > 0) then
		if not nocreate then
			if name then
				local numglobal, numperchar = GetNumMacros()
				local pc = 0
				local num = numglobal
				if percharacter == 1 then
					pc = 1
					num = numperchar
					globalorlocal = "per character"
				end
				if num < 18 then
					CreateMacro(name, macroiconindex, macro, 1, pc)
					macroindex = GetMacroIndexByName(name)
					if macroindex > 0 then
						SpellFlashAddon.debug("Created  '"..name.."'  macro in "..globalorlocal.." index: "..macroindex, show)
						return true
					end
				elseif name then
					SpellFlashAddon.debug("No "..globalorlocal.." macro spaces left to create  '"..name.."'  macro!", show)
				else
					SpellFlashAddon.debug("No "..globalorlocal.." macro spaces left to create macro!", show)
				end
			end
		end
	elseif macroindex > 0 then
		if replace or replacemacroindex then
			if replacemacroname then
				EditMacro(macroindex, name, macroiconindex, macro, 1)
				if name then
					SpellFlashAddon.debug("Replaced  '"..name.."'  macro in index: "..macroindex, show)
				else
					SpellFlashAddon.debug("Replaced macro in index: "..macroindex, show)
				end
			else
				EditMacro(macroindex, nil, macroiconindex, macro, 1)
				if name then
					SpellFlashAddon.debug("Replaced  '"..name.."'  macro in index: "..macroindex, show)
				else
					SpellFlashAddon.debug("Replaced macro in index: "..macroindex, show)
				end
			end
		elseif name then
			SpellFlashAddon.debug("Found  '"..name.."'  macro in index: "..macroindex, show)
		else
			SpellFlashAddon.debug("Found macro in index: "..macroindex, show)
		end
		return true
	end
	return false
end




function SpellFlashAddon.EditMacro(name, macro, macroicontecture, iconindex, show, replacemacroindex, replacemacroname)
	return SpellFlashAddon.MakeMacro(name, macro, nil, macroicontecture, iconindex, 1, show, 1, replacemacroindex, replacemacroname)
end



function SpellFlashAddon.GiveMacroIconIndex(texture)
	for i=1,GetNumMacroIcons() do
		if (string.find(GetMacroIconInfo(i), texture)) then
			SpellFlashAddon.debug("Macro Icon Index#"..i.." for texture:"..texture, 2)
			return i
		end
	end
	SpellFlashAddon.debug("Macro Icon Index# not found for texture:"..texture, 2)
	return nil
end

-- Test Function
function SpellFlashAddon.ShowAllMacroIconIndexTextures(numberstart, numberend)
	local s = 1
	local e = GetNumMacroIcons()
	if numberend then
		if numberend <= e and numberend >= s then
			e = numberend
		end
	end
	if numberstart then
		if numberstart <= e and numberstart >= s then
			s = numberstart
		end
	end
	if s > e then
		return false
	end
	if GetNumMacroIcons() >= s then
		for i=s,e do
			SpellFlashAddon.msg("Macro Icon Index#"..i..": Texture: "..GetMacroIconInfo(i))
		end
		return true
	end
	return false
end



-- Must use "PET_ACTION_ATTACK" instead of the corresponding localized name.
-- Must use "PET_ACTION_FOLLOW" instead of the corresponding localized name.
-- Must use "PET_ACTION_WAIT" instead of the corresponding localized name.
-- Must use "PET_MODE_AGGRESSIVE" instead of the corresponding localized name.
-- Must use "PET_MODE_DEFENSIVE" instead of the corresponding localized name.
-- Must use "PET_MODE_PASSIVE" instead of the corresponding localized name.
function SpellFlashAddon.PetBarActionCastable(SpellName, PetTargetNeeded)
	if UnitHealth("pet") > 0 and ( not PetTargetNeeded or UnitExists("pet") ) then
		for i=1,NUM_PET_ACTION_SLOTS do
			local name, subtext, texture, isToken, isActive = GetPetActionInfo(i)
			if name == SpellName then
				if isActive then
					return false
				end
				if not GetPetActionSlotUsable(i) then
					return false
				end
				local _, cool = GetPetActionCooldown(i)
				if cool > 0 then
					return false
				end
				return true
			end
		end
	end
	return false
end


function SpellFlashAddon.CheckIfSpellCastable(InfoArray)
	if type(InfoArray) ~= "table" then
		if not InfoArray then
			return false
		end
		InfoArray = {["SpellName"] = InfoArray}
	elseif not InfoArray.SpellName then
		return false
	end
	if SpellFlashAddon.isImmune(InfoArray.SpellName, UnitName("target")) then
		return false
	end
	local isUsable, notEnoughMana = IsUsableSpell(InfoArray.SpellName)
	local _, cool = GetSpellCooldown(InfoArray.SpellName)
	if isUsable and not notEnoughMana and cool == 0 then
		if InfoArray.EvenIfCasting or ( not IsCurrentSpell(InfoArray.SpellName) and not SpellFlashAddon.isCastingOrChanneling() ) then
			if InfoArray.NoRangeCheck or not SpellHasRange(InfoArray.SpellName) or IsSpellInRange(InfoArray.SpellName,InfoArray.BuffUnit) == 1 then
				if not InfoArray.EnemyTargetNeeded or SpellFlashAddon.isEnemy() then
					if not InfoArray.TargetThatUsesManaNeeded or UnitPowerType("target") == 0 then
						if not InfoArray.DebuffName or ( ( not InfoArray.DebuffSlotNeeded or not SpellFlashAddon.AllDebuffSlotsUsed() ) and not SpellFlashAddon.checkDebuff(InfoArray.DebuffName,nil,InfoArray.IsMine,nil,InfoArray.DebuffCastTime,nil,nil,nil,nil,InfoArray.CheckDebuffRank) ) then
							if not InfoArray.BuffName or not SpellFlashAddon.checkBuff(InfoArray.BuffName,InfoArray.BuffUnit,InfoArray.IsMine,nil,InfoArray.BuffCastTime) then
								return true
							end
						end
					end
				end
			end
		end
	end
	return false
end



--[[ Example code:

function SpellFlashAddon.Castable.SpellName()
	local z = {}
	z.SpellName = 
	z.DebuffName = z.SpellName
	z.DebuffSlotNeeded = 1
	z.CheckDebuffRank = SpellFlashAddon.GetSpellRank(z.DebuffName)
	z.DebuffCastTime = SpellFlashAddon.GetSpellCastTime(z.DebuffName)
	z.BuffName = z.SpellName
	z.BuffCastTime = SpellFlashAddon.GetSpellCastTime(z.BuffName)
	z.BuffUnit = 
	z.IsMine = 1
	z.EnemyTargetNeeded = 1
	z.TargetThatUsesManaNeeded = 1
	z.NoRangeCheck = 1
	z.EvenIfCasting = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

]]



function SpellFlashAddon.SetTimer(Seconds, Name, Pre, Tag, RepeatSeconds, Function, FuncArg1, FuncArg2, FuncArg3, FuncArg4, FuncArg5, FuncArg6, FuncArg7, FuncArg8, FuncArg9, FuncArg10)
	if Name and Name ~= "" then
		local fn = (Pre or "").."___Pre_DEVIDER_123__"..Name.."___Tag_DEVIDER_456__"..(Tag or "")
		TIMER[fn] = {}
		TIMER[fn]["Seconds"] = Seconds or 0
		if RepeatSeconds then
			TIMER[fn]["Name"] = Name
			TIMER[fn]["Pre"] = Pre
			TIMER[fn]["Tag"] = Tag
			TIMER[fn]["RepeatSeconds"] = RepeatSeconds
		end
		if Function then
			TIMER[fn]["Function"] = Function
			TIMER[fn]["FuncArg1"] = FuncArg1
			TIMER[fn]["FuncArg2"] = FuncArg2
			TIMER[fn]["FuncArg3"] = FuncArg3
			TIMER[fn]["FuncArg4"] = FuncArg4
			TIMER[fn]["FuncArg5"] = FuncArg5
			TIMER[fn]["FuncArg6"] = FuncArg6
			TIMER[fn]["FuncArg7"] = FuncArg7
			TIMER[fn]["FuncArg8"] = FuncArg8
			TIMER[fn]["FuncArg9"] = FuncArg9
			TIMER[fn]["FuncArg10"] = FuncArg10
		end
	end
end

function SpellFlashAddon.IsTimer(Name, Pre, Tag)
	local fn = (Pre or "").."___Pre_DEVIDER_123__"..(Name or "").."___Tag_DEVIDER_456__"..(Tag or "")
	if TIMER[fn] then
		return true
	end
	return false
end

function SpellFlashAddon.GetTimer(Name, Pre, Tag)
	local fn = (Pre or "").."___Pre_DEVIDER_123__"..(Name or "").."___Tag_DEVIDER_456__"..(Tag or "")
	if TIMER[fn] then
		return TIMER[fn]["Seconds"]
	end
	return 0
end

function SpellFlashAddon.ClearTimer(Name, Pre, Tag)
	local fn = (Pre or "").."___Pre_DEVIDER_123__"..(Name or "").."___Tag_DEVIDER_456__"..(Tag or "")
	if TIMER[fn] then
		TIMER[fn] = nil
	end
end






function SpellFlashAddon.WipeButtons()
	BUTTONSREGISTERED = nil
	SpellFlashAddon.Button = {}
	SpellFlashAddon.ButtonMaxRank = {}
	SpellFlashAddon.ButtonAll = {}
	SpellFlashAddon.ButtonAllMaxRank = {}
end

function SpellFlashAddon.RegisterButtons()
	SpellFlashAddon.WipeButtons()
	if not TALENTSREGISTERED then
		SpellFlashAddon.RegisterTalents()
	end
	local MAX = {}
	local MAXFOUND = {}
	for i=1,120 do
		local SpellName, SpellRank, MacroText = SpellFlashAddon.GetActionSpellInfo(i)
		if MacroText then
			if not SpellFlashAddon.Button["Macro."..MacroText] then
				SpellFlashAddon.Button["Macro."..MacroText] = i
			end
			if not SpellFlashAddon.ButtonAll["Macro."..MacroText] then
				SpellFlashAddon.ButtonAll["Macro."..MacroText] = {}
			end
			SpellFlashAddon.ButtonAll["Macro."..MacroText][i..""] = i
		elseif SpellName then
			if not SpellFlashAddon.Button[SpellName.."."..SpellRank] then
				if not MAX[SpellName] then
					MAX[SpellName] = SpellFlashAddon.GetSpellRank(SpellName)
				end
				SpellFlashAddon.Button[SpellName.."."..SpellRank] = i
				if not SpellFlashAddon.ButtonMaxRank[SpellName] and SpellRank == MAX[SpellName] then
					SpellFlashAddon.ButtonMaxRank[SpellName] = i
				end
				if not MAXFOUND[SpellName] or SpellRank > MAXFOUND[SpellName] then
					SpellFlashAddon.Button[SpellName] = i
					MAXFOUND[SpellName] = SpellRank
				end
				if not SpellFlashAddon.ButtonAll[SpellName] then
					SpellFlashAddon.ButtonAll[SpellName] = {}
				end
			end
			SpellFlashAddon.ButtonAll[SpellName][i..""] = i
			if SpellRank == MAX[SpellName] then
				if not SpellFlashAddon.ButtonAllMaxRank[SpellName] then
					SpellFlashAddon.ButtonAllMaxRank[SpellName] = {}
				end
				SpellFlashAddon.ButtonAllMaxRank[SpellName][i..""] = i
			end
		end
	end
	if IsAddOnLoaded("ExtraBar") then
		for i=1,4 do
			local c = 1
			local frame = getglobal("ExtraBar"..i.."Button"..c)
			while frame do
				local SpellName = nil
				if frame.set1name and frame.set1name ~= "" then
					SpellName = frame.set1name
				elseif frame.set2name and frame.set2name ~= "" then
					SpellName = frame.set2name
				end
				if SpellName then
					local macro = ""
					if frame.set1type == "macro" or frame.set2type == "macro" then
						macro = "Macro."
					end
					if not SpellFlashAddon.ButtonAll["ExtraBar."..macro..""..SpellName] then
						SpellFlashAddon.ButtonAll["ExtraBar."..macro..""..SpellName] = {}
					end
					SpellFlashAddon.ButtonAll["ExtraBar."..macro..""..SpellName][i..""..c] = frame
				end
				c = c + 1
				frame = getglobal("ExtraBar"..i.."Button"..c)
			end
		end
	end
	BUTTONSREGISTERED = 1
end

function SpellFlashAddon.GetActionSpellInfo(slot)
	if slot and HasAction(slot) then
		local MacroText = GetActionText(slot)
		if MacroText then
			return nil, nil, MacroText
		end
		local abilityType, id, subType, globalID = GetActionInfo(slot)
		if globalID then
			local SpellName, RankName = GetSpellInfo(globalID)
			local SpellRank = 1
			if RankName ~= "" then
				local found, _, rank = string.find(RankName, "(%d+)")
				if found then
					SpellRank = tonumber(rank)
				end
			end
			return SpellName, SpellRank
		end
	end	
	return nil
end



function SpellFlashAddon.FlashableButtonFound(SpellName)
	if SpellFlashAddon.IsSpellKnown(SpellName) and (
		SpellFlashAddon.ButtonAll[SpellName] or
		SpellFlashAddon.ButtonAll["Macro."..string.sub(SpellName,1,15).."F"] or
		SpellFlashAddon.ButtonAll["ExtraBar."..SpellName] or
		SpellFlashAddon.ButtonAll["ExtraBar.Macro."..string.sub(SpellName,1,15).."F"]
	) then
		return true
	end
	return false
end



-- Must use "PET_ACTION_ATTACK" instead of the corresponding localized name.
-- Must use "PET_ACTION_FOLLOW" instead of the corresponding localized name.
-- Must use "PET_ACTION_WAIT" instead of the corresponding localized name.
-- Must use "PET_MODE_AGGRESSIVE" instead of the corresponding localized name.
-- Must use "PET_MODE_DEFENSIVE" instead of the corresponding localized name.
-- Must use "PET_MODE_PASSIVE" instead of the corresponding localized name.
function SpellFlashAddon.FlashPetButtonBySpellName(SpellName, red, green, blue)
	if SpellName then
		local FrameString
		if IsAddOnLoaded("Bartender4") then
			FrameString = "BT4PetButton"
		elseif IsAddOnLoaded("nUI") then
			FrameString = "nUI_PetBar_Button"
		else
			FrameString = "PetActionButton"
		end
		for i=1,NUM_PET_ACTION_SLOTS do
			if GetPetActionInfo(i) == SpellName then
				SpellFlashAddon.FlashFrame(getglobal(FrameString..""..i), red, green, blue)
				return
			end
		end
	end
end

function SpellFlashAddon.FlashFormButtonBySpellName(SpellName, red, green, blue)
	if SpellName then
		local FrameString
		if IsAddOnLoaded("Bartender4") then
			FrameString = "BT4StanceButton"
		elseif IsAddOnLoaded("Dominos") then
			FrameString = "DominosClassButton"
		elseif IsAddOnLoaded("nUI") then
			FrameString = "nUI_ShapeshiftBar_Button"
		else
			FrameString = "ShapeshiftButton"
		end
		for i=1,GetNumShapeshiftForms() do
			local _, form = GetShapeshiftFormInfo(i)
			if form == SpellName then
				SpellFlashAddon.FlashFrame(getglobal(FrameString..""..i), red, green, blue)
				return
			end
		end
	end
end

function SpellFlashAddon.FlashActionButtonBySpellName(SpellName, red, green, blue)
	if BUTTONSREGISTERED and SpellName and SpellName ~= "" then
		if SpellFlashAddon.ButtonAll[SpellName] then
			for n,v in pairs(SpellFlashAddon.ButtonAll[SpellName]) do
				SpellFlashAddon.FlashActionButton(v, red, green, blue)
			end
		end
		if SpellFlashAddon.ButtonAll["Macro."..string.sub(SpellName,1,15).."F"] then
			for n,v in pairs(SpellFlashAddon.ButtonAll["Macro."..string.sub(SpellName,1,15).."F"]) do
				SpellFlashAddon.FlashActionButton(v, red, green, blue)
			end
		end
		if IsAddOnLoaded("ExtraBar") then
			if SpellFlashAddon.ButtonAll["ExtraBar."..SpellName] then
				for n,v in pairs(SpellFlashAddon.ButtonAll["ExtraBar."..SpellName]) do
					SpellFlashAddon.FlashFrame(v, red, green, blue)
				end
			end
			if SpellFlashAddon.ButtonAll["ExtraBar.Macro."..string.sub(SpellName,1,15).."F"] then
				for n,v in pairs(SpellFlashAddon.ButtonAll["ExtraBar.Macro."..string.sub(SpellName,1,15).."F"]) do
					SpellFlashAddon.FlashFrame(v, red, green, blue)
				end
			end
		end
	end
end

function SpellFlashAddon.FlashActionButton(button, red, green, blue)
	if button then
		local FrameString
		if IsAddOnLoaded("Bartender4") then
			FrameString = {
				"BT4Button",
			}
		elseif IsAddOnLoaded("Dominos") then
			FrameString = {
				"ActionButton",
				"BonusActionButton",
				"MultiBarBottomLeftButton",
				"MultiBarBottomRightButton",
				"MultiBarRightButton",
				"MultiBarLeftButton",
				"DominosActionButton",
			}
		elseif IsAddOnLoaded("nUI") then
			FrameString = {
				"nUI_ActionBar_Button",
				"nUI_TopLeftBar_Button",
				"nUI_TopRightBar_Button",
				"nUI_BottomLeftBar_Button",
				"nUI_BottomRightBar_Button",
				"nUI_LeftUnitBar_Button",
				"nUI_RightUnitBar_Button",
			}
		else
			FrameString = {
				"ActionButton",
				"BonusActionButton",
				"MultiBarBottomLeftButton",
				"MultiBarBottomRightButton",
				"MultiBarRightButton",
				"MultiBarLeftButton",
			}
		end
		for i,v in ipairs(FrameString) do
			local c = 1
			local frame = getglobal(v..""..c)
			while frame do
				if frame.action == button then
					SpellFlashAddon.FlashFrame(frame, red, green, blue)
					return
				end
				c = c + 1
				frame = getglobal(v..""..c)
			end
		end
	end
end

function SpellFlashAddon.FlashFrame(frame, red, green, blue)
	if frame then
		if not frame.SpellFlashAddonFlashFrame then
			frame.SpellFlashAddonFlashFrame = CreateFrame("Frame", nil, frame)
			frame.SpellFlashAddonFlashFrame:SetAllPoints(frame)
			frame.SpellFlashAddonFlashFrame.FlashTexture = frame.SpellFlashAddonFlashFrame:CreateTexture(nil, "OVERLAY")
			frame.SpellFlashAddonFlashFrame.FlashTexture:SetTexture("Interface\\Cooldown\\star4")
			frame.SpellFlashAddonFlashFrame.FlashTexture:SetPoint("CENTER", frame.SpellFlashAddonFlashFrame, "CENTER")
			frame.SpellFlashAddonFlashFrame.FlashTexture:SetBlendMode("ADD")
			frame.SpellFlashAddonFlashFrame:Hide()
			frame.SpellFlashAddonFlashFrame:SetScript("OnUpdate", SpellFlashAddon.FlashFrame_OnUpdate)
			frame.SpellFlashAddonFlashFrame:SetAlpha(1)
		end
		frame.SpellFlashAddonFlashFrame.FlashModifier = 1
		frame.SpellFlashAddonFlashFrame.FlashTexture:SetAlpha(1 * FLASHBRIGHTNESS)
		frame.SpellFlashAddonFlashFrame.FlashTexture:SetHeight(frame.SpellFlashAddonFlashFrame:GetHeight() * FLASHSIZE)
		frame.SpellFlashAddonFlashFrame.FlashTexture:SetWidth(frame.SpellFlashAddonFlashFrame:GetWidth() * FLASHSIZE)
		frame.SpellFlashAddonFlashFrame.FlashTexture:SetVertexColor(red or 1, green or 1, blue or 1)
		frame.SpellFlashAddonFlashFrame:Show()
	end
end

function SpellFlashAddon.FlashFrame_OnUpdate(frame, arg1)
	local modifier = frame.FlashModifier
	frame.FlashModifier = modifier - modifier * arg1
	local newalpha = frame.FlashModifier * FLASHBRIGHTNESS
	if frame.FlashModifier < 0.1 or newalpha <= 0 then
		frame:Hide()
	else
		frame.FlashTexture:SetHeight(modifier * frame:GetHeight() * FLASHSIZE)
		frame.FlashTexture:SetWidth(modifier * frame:GetWidth() * FLASHSIZE)
		frame.FlashTexture:SetAlpha(newalpha)
	end
end



