--------   All functions below this line will only load if you are playing the corresponding class   --------
if not SpellFlashAddon.DRUID then return end



function SpellFlashAddon.isCasterForm()
	return ( not SpellFlashAddon.isForm() )
end

function SpellFlashAddon.isFeralForm()
	return SpellFlashAddon.isForm()
end


function SpellFlashAddon.isTravelForm()
	return SpellFlashAddon.isForm((GetSpellInfo(783))--[["Travel Form"]])
end

function SpellFlashAddon.isMoonkinForm()
	return SpellFlashAddon.isForm((GetSpellInfo(24858))--[["Moonkin Form"]])
end

function SpellFlashAddon.isCatForm(unit)
	return SpellFlashAddon.isForm((GetSpellInfo(768))--[["Cat Form"]])
end

function SpellFlashAddon.isAquaticForm(unit)
	return SpellFlashAddon.isForm((GetSpellInfo(1066))--[["Aquatic Form"]])
end

function SpellFlashAddon.isBearForm()
	return SpellFlashAddon.DRUID.CheckForm((GetSpellInfo(5487))--[["Bear Form"]])
end

function SpellFlashAddon.isFlightForm()
	return SpellFlashAddon.DRUID.CheckForm((GetSpellInfo(33943))--[["Flight Form"]])
end

-- Will return true if you are in the queried form.
-- Example: SpellFlashAddon.DRUID.CheckForm("Bear Form")
-- The example above will return true if you are currently in the Bear Form or Dire Bear Form.
function SpellFlashAddon.DRUID.CheckForm(form)
	if form == (GetSpellInfo(33943))--[["Flight Form"]] or form == (GetSpellInfo(40120))--[["Swift Flight Form"]] then
		return ( SpellFlashAddon.isForm((GetSpellInfo(40120))--[["Swift Flight Form"]]) or SpellFlashAddon.isForm((GetSpellInfo(33943))--[["Flight Form"]]) )
	elseif form == (GetSpellInfo(5487))--[["Bear Form"]] or form == (GetSpellInfo(9634))--[["Dire Bear Form"]] then
		return ( SpellFlashAddon.isForm((GetSpellInfo(9634))--[["Dire Bear Form"]]) or SpellFlashAddon.isForm((GetSpellInfo(5487))--[["Bear Form"]]) )
	end
	return SpellFlashAddon.isForm(form)
end



--Returns true if Mark of the Wild is active on the target
function SpellFlashAddon.isMarkOfTheWild(unit)
	return SpellFlashAddon.checkBuff(nil,unit or "target",nil,nil,nil,nil,nil,"Spell_Nature_Regeneration")
end

--Returns true if Thorns is active on the target
function SpellFlashAddon.isThorns(unit)
	return SpellFlashAddon.checkBuff(nil,unit or "target",nil,nil,nil,nil,nil,"Spell_Nature_Thorns")
end

--Returns true if Thorns is active on the target
function SpellFlashAddon.isRejuvenation(unit)
	return SpellFlashAddon.checkBuff(nil,unit or "target",nil,nil,nil,nil,nil,"Spell_Nature_Rejuvenation")
end

--Returns true if Thorns is active on the target
function SpellFlashAddon.isRegrowth(unit)
	return SpellFlashAddon.checkBuff(nil,unit or "target",nil,nil,nil,nil,nil,"Spell_Nature_ResistNature")
end



--Returns true if the target has Entangling Root on it
function SpellFlashAddon.isRooted(unit)
	return SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,nil,"Spell_Nature_StrangleVines")
end

--Returns true if the target has Insect Swarm on it
function SpellFlashAddon.isInsectSwarm(unit)
	return SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,nil,"Spell_Nature_InsectSwarm")
end

--Returns true if the target has Faerie Fire on it
function SpellFlashAddon.isFaerieFire(unit)
	return SpellFlashAddon.checkDebuff((GetSpellInfo(770))--[["Faerie Fire"]],unit)
end

--Returns true if the target has Moonfire on it
function SpellFlashAddon.isMoonfire(unit)
	return SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,nil,"Spell_Nature_StarFall")
end







-- Added by: Nosrac
function SpellFlashAddon.isOmenOfClarityActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Spell_Nature_CrystalBall")
end

--Returns true if Mark of the Wild is active
function SpellFlashAddon.isMarkOfTheWildActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Spell_Nature_Regeneration")
end

--Returns true if Thorns is active
function SpellFlashAddon.isThornsActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Spell_Nature_Thorns")
end

--Returns true if Thorns is active
function SpellFlashAddon.isRejuvenationActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Spell_Nature_Rejuvenation")
end

--Returns true if Thorns is active
function SpellFlashAddon.isRegrowthActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Spell_Nature_ResistNature")
end


-- Added by: Nosrac
-- Edited by: BigRedBrent
function SpellFlashAddon.Castable.OmenOfClarity()
	local z = {}
	z.SpellName = (GetSpellInfo(16864))--[["Omen of Clarity"]]
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


-- Will cast the spell if it is not on your target, if it is on your target or it can not be cast on your target, then it will cast on yourself if it is not on you.
function SpellFlashAddon.Castable.MarkOfTheWild()
	local SpellName = (GetSpellInfo(1126))--[["Mark of the Wild"]]
	local SpellButton = SpellFlashAddon.Button[SpellName]
	local friend = nil;
	if SpellButton then
		if not SpellFlashAddon.isCasterForm() then
			return castCasterForm()
		else
			local isUsable, notEnoughMana = IsUsableSpell(SpellName)
			local _, duration, _ = GetSpellCooldown(SpellName)
			local inRange = IsSpellInRange(SpellName)
			local isCurrent = IsCurrentSpell(SpellName)
			if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target") and ( isUsable ) and ( not notEnoughMana ) and ( duration == 0 ) and ( inRange == 1 ) and not ( isCurrent == 1 ) and (not isMarkOfTheWild())) then
				UseAction(SpellButton)
				if SpellIsTargeting() then
					SpellStopTargeting()
					return false
				end
				return true
			elseif ( isUsable == 1 ) and ( not notEnoughMana ) and ( duration == 0 ) and not ( isCurrent == 1 ) and (not SpellFlashAddon.isMarkOfTheWildActive()) then
				if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target")) then
					friend = 1;
					TargetUnit("player");
				end
				UseAction(SpellButton)
				if (friend) then
					TargetLastTarget();
				end
				if SpellIsTargeting() then
					if SpellCanTargetUnit("player") then
						SpellTargetUnit("player")
					else
						SpellStopTargeting()
						return false
					end
				end
				return true
			end
		end
	elseif SpellFlashAddon.IsSpellKnown(SpellName) then
		SpellFlashAddon.debug(""..SpellName.." was not found on any of the action bars!")
		if not SpellFlashAddon.isCasterForm() then
			return castCasterForm()
		else
			local SpellID = SpellFlashAddon.GetSpellID(SpellName)
			if not SpellFlashAddon.OnCooldown(SpellName) then
				if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target") and not SpellFlashAddon.isMarkOfTheWild()) then
					CastSpell(SpellID, 0)
					if SpellIsTargeting() then
						SpellStopTargeting()
						return false
					end
					return true
				elseif (not SpellFlashAddon.isMarkOfTheWildActive()) then
					if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target")) then
						friend = 1;
						TargetUnit("player");
					end
					CastSpell(SpellID, 0)
					if (friend) then
						TargetLastTarget();
					end
					if SpellIsTargeting() then
						if SpellCanTargetUnit("player") then
							SpellTargetUnit("player")
						else
							SpellStopTargeting()
							return false
						end
					end
					return true
				end
			end
		end
	end
	return false
end




-- Will cast the spell if it is not on your target, if it is on your target or it can not be cast on your target, then it will cast on yourself if it is not on you.
function SpellFlashAddon.Castable.Thorns()
	local SpellName = (GetSpellInfo(467))--[["Thorns"]]
	local SpellButton = SpellFlashAddon.Button[SpellName]
	local friend = nil;
	if SpellButton then
		if not SpellFlashAddon.isCasterForm() and not SpellFlashAddon.isMoonkinForm() then
			return castCasterForm()
		else
			local isUsable, notEnoughMana = IsUsableSpell(SpellName)
			local _, duration, _ = GetSpellCooldown(SpellName)
			local inRange = IsSpellInRange(SpellName, "target")
			local isCurrent = IsCurrentSpell(SpellName)
			if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target") and ( isUsable == 1 ) and ( not notEnoughMana ) and ( duration == 0 ) and ( inRange == 1 ) and not ( isCurrent == 1 ) and (not SpellFlashAddon.isThorns())) then
				UseAction(SpellButton)
				if SpellIsTargeting() then
					SpellStopTargeting()
					return false
				end
				return true
			elseif ( isUsable == 1 ) and ( not notEnoughMana ) and ( duration == 0 ) and not ( isCurrent == 1 ) and (not SpellFlashAddon.isThornsActive()) then
				if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target")) then
					friend = 1;
					TargetUnit("player");
				end
				UseAction(SpellButton)
				if (friend) then
					TargetLastTarget();
				end
				if SpellIsTargeting() then
					if SpellCanTargetUnit("player") then
						SpellTargetUnit("player")
					else
						SpellStopTargeting()
						return false
					end
				end
				return true
			end
		end
	elseif SpellFlashAddon.IsSpellKnown(SpellName) then
		SpellFlashAddon.debug(""..SpellName.." was not found on any of the action bars!")
		if not SpellFlashAddon.isCasterForm() and not SpellFlashAddon.isMoonkinForm() then
			return castCasterForm()
		else
			local SpellID = SpellFlashAddon.GetSpellID(SpellName)
			if not SpellFlashAddon.OnCooldown(SpellName) then
				if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target") and not SpellFlashAddon.isThorns()) then
					CastSpell(SpellID, 0)
					if SpellIsTargeting() then
						SpellStopTargeting()
						return false
					end
					return true
				elseif (not SpellFlashAddon.isThornsActive()) then
					if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target")) then
						friend = 1;
						TargetUnit("player");
					end
					CastSpell(SpellID, 0)
					if (friend) then
						TargetLastTarget();
					end
					if SpellIsTargeting() then
						if SpellCanTargetUnit("player") then
							SpellTargetUnit("player")
						else
							SpellStopTargeting()
							return false
						end
					end
					return true
				end
			end
		end
	end
	return false
end







-- From: Jiral
-- Casts Healing Touch of a rank appropriate to the damage taken.
--   Note: WoW doesn't return actual health numbers for non-self/party/raid members (only percents), so maximum rank will be used by default
function SpellFlashAddon.Castable.HealingTouch(Mode, RankAdj, unit)
	local SpellName = (GetSpellInfo(5185))--[["Healing Touch"]]
end



-- From: Jiral
function SpellFlashAddon.Castable.Regrowth(Mode, RankAdj, unit)
	local SpellName = (GetSpellInfo(8936))--[["Regrowth"]]
end






-- From: Jiral
function SpellFlashAddon.Castable.Rejuvenation(Mode, RankAdj, unit)
	local SpellName = (GetSpellInfo(774))--[["Rejuvenation"]]
end






function SpellFlashAddon.Castable.Swiftmend()
	local SpellName = (GetSpellInfo(18562))--[["Swiftmend"]]
end



function SpellFlashAddon.Castable.Innervate()
	local SpellName = (GetSpellInfo(29166))--[["Innervate"]]
end





--Added by Mithrael
--Returns true if Barkskin is active
function SpellFlashAddon.isBarkskinActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Spell_Nature_StoneClawTotem")
end

--Added by Mithrael
--Returns true if Nature's Grasp is active
function SpellFlashAddon.isNaturesGraspActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Spell_Nature_NaturesWrath")
end

--Added by Mithrael
--Returns true if Prowl is active
function SpellFlashAddon.isProwlActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Ability_Ambush")
end

--Added by Mithrael
--Returns true if Nature's Swiftness is active
function SpellFlashAddon.isNaturesSwiftnessActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Spell_Nature_RavenForm")
end

--Added by Mithrael
--If Bark Skin is not already active, it will cast it
function SpellFlashAddon.Castable.Barkskin()
	local z = {}
	z.SpellName = (GetSpellInfo(22812))--[["Barkskin"]]
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by Mithrael
--If Nature's Grasp is not already active, it will cast it
function SpellFlashAddon.Castable.NaturesGrasp()
	local z = {}
	z.SpellName = (GetSpellInfo(16689))--[["Nature's Grasp"]]
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by Mithrael
--If Prowl is not already active, it will cast it
function SpellFlashAddon.Castable.Prowl()
	local z = {}
	z.SpellName = (GetSpellInfo(5215))--[["Prowl"]]
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by Mithrael
--If Nature's Swiftness is not already active, it will cast it
function SpellFlashAddon.Castable.NaturesSwiftness()
	local z = {}
	z.SpellName = (GetSpellInfo(17116))--[["Nature's Swiftness"]]
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


--Added by Mithrael
function SpellFlashAddon.Castable.EntanglingRoots()
	local z = {}
	z.SpellName = (GetSpellInfo(339))--[["Entangling Roots"]]
	z.DebuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by Mithrael
function SpellFlashAddon.Castable.InsectSwarm()
	local z = {}
	z.SpellName = (GetSpellInfo(5570))--[["Insect Swarm"]]
	z.DebuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by Mithrael
--Edited by BigRedBrent
function SpellFlashAddon.Castable.FaerieFire()
	local SpellName = (GetSpellInfo(770))--[["Faerie Fire"]]
	local FeralSpellName = (GetSpellInfo(16857))--[["Faerie Fire (Feral)"]]
	if SpellFlashAddon.IsSpellKnown(FeralSpellName) and (SpellFlashAddon.isDireBearForm() or SpellFlashAddon.isBearForm() or SpellFlashAddon.isCatForm()) then
		local SpellID = SpellFlashAddon.GetSpellID(FeralSpellName)
		if SpellFlashAddon.TargetIsEnemy() and not SpellFlashAddon.OnCooldown(FeralSpellName) and not isFaerieFire() then
			CastSpell(SpellID, 0)
			return true
		end
	elseif SpellFlashAddon.IsSpellKnown(SpellName) then
		if isCasterForm() or isMoonkinForm() then
			local SpellID = SpellFlashAddon.GetSpellID(SpellName)
			if SpellFlashAddon.TargetIsEnemy() and not SpellFlashAddon.OnCooldown(SpellName) and not isFaerieFire() then
				CastSpell(SpellID, 0)
				return true
			end
		else
			return castCasterForm()
		end
	end
	return false
end

--Added by Mithrael
--Edited by BigRedBrent
function SpellFlashAddon.Castable.Moonfire(NoDebuffCheck)
	local z = {}
	z.SpellName = (GetSpellInfo(8921))--[["Moonfire"]]
	if not NoDebuffCheck then
		z.DebuffName = z.SpellName
	end
	z.IsMine = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by Mithrael
function SpellFlashAddon.Castable.Starfire()
	local z = {}
	z.SpellName = (GetSpellInfo(2912))--[["Starfire"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


function SpellFlashAddon.Castable.Wrath()
	local z = {}
	z.SpellName = (GetSpellInfo(5176))--[["Wrath"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end



