--------   All functions below this line will only load if you are playing the corresponding class   --------
if not SpellFlashAddon.HUNTER then return end



--Returns true if the target has Wing Clip on it
function SpellFlashAddon.isClipped(unit)
	return SpellFlashAddon.checkDebuff((GetSpellInfo(2974))--[["Wing Clip"]],unit)
end

--Returns true if the target has Concussion Shot on it
function SpellFlashAddon.isConcussiveShot(unit)
	return SpellFlashAddon.checkDebuff((GetSpellInfo(5116))--[["Concussive Shot"]],unit)
end

--Returns true if the target has Hunter's Mark cast on it already
function SpellFlashAddon.isMarked(unit)
	return SpellFlashAddon.checkDebuff((GetSpellInfo(1130))--[["Hunter's Mark"]],unit,nil,nil,nil,nil,nil,nil,nil,SpellFlashAddon.GetSpellRank((GetSpellInfo(1130))--[["Hunter's Mark"]]))
end

function SpellFlashAddon.isScatterShot(unit)
	return SpellFlashAddon.checkDebuff((GetSpellInfo(19503))--[["Scatter Shot"]],unit)
end

function SpellFlashAddon.isScorpidSting(unit, mine)
	return SpellFlashAddon.checkDebuff((GetSpellInfo(3043))--[["Scorpid Sting"]],unit,mine)
end

function SpellFlashAddon.isViperSting(unit, any)
	return SpellFlashAddon.checkDebuff((GetSpellInfo(3034))--[["Viper Sting"]],unit,not any)
end

function SpellFlashAddon.isWyvernSting(unit, any)
	return SpellFlashAddon.checkDebuff((GetSpellInfo(19386))--[["Wyvern Sting"]],unit,not any)
end

function SpellFlashAddon.isSerpentSting(unit, any)
	return SpellFlashAddon.checkDebuff((GetSpellInfo(1978))--[["Serpent Sting"]],unit,not any)
end


function SpellFlashAddon.isStung(unit, any)
	return SpellFlashAddon.checkDebuff({(GetSpellInfo(1978))--[["Serpent Sting"]],(GetSpellInfo(3034))--[["Viper Sting"]],(GetSpellInfo(3043))--[["Scorpid Sting"]],(GetSpellInfo(19386))--[["Wyvern Sting"]]},unit,not any)
end





function SpellFlashAddon.Castable.AutoShot()
	if SpellFlashAddon.AutoShoot then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(75))--[["Auto Shot"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


--Returns true if you are not in combat and can place a trap
function SpellFlashAddon.canTrap()
	if (SpellFlashAddon.Combat) then
		return false
	end
	return true
end

--Returns true if any Aspect is active
function SpellFlashAddon.isAspectActive()
	if
		SpellFlashAddon.isDragonhawkActive() or
		SpellFlashAddon.isViperActive() or
		SpellFlashAddon.isHawkActive() or
		SpellFlashAddon.isMonkeyActive() or
		SpellFlashAddon.isCheetahActive() or
		SpellFlashAddon.isBeastActive() or
		SpellFlashAddon.isWildActive() or
		SpellFlashAddon.isPackActive()
	then
		return true
	end
	return false
end


function SpellFlashAddon.GiveAspect()
	if SpellFlashAddon.isDragonhawkActive() then
		return (GetSpellInfo(61846))--[["Aspect of the Dragonhawk"]]
	elseif SpellFlashAddon.isViperActive() then
		return (GetSpellInfo(34074))--[["Aspect of the Viper"]]
	elseif SpellFlashAddon.isHawkActive() then
		return (GetSpellInfo(13165))--[["Aspect of the Hawk"]]
	elseif SpellFlashAddon.isMonkeyActive() then
		return (GetSpellInfo(13163))--[["Aspect of the Monkey"]]
	elseif SpellFlashAddon.isCheetahActive() then
		return (GetSpellInfo(5118))--[["Aspect of the Cheetah"]]
	elseif SpellFlashAddon.isBeastActive() then
		return (GetSpellInfo(13161))--[["Aspect of the Beast"]]
	elseif SpellFlashAddon.isWildActive() then
		return (GetSpellInfo(20043))--[["Aspect of the Wild"]]
	elseif SpellFlashAddon.isPackActive() then
		return (GetSpellInfo(13159))--[["Aspect of the Pack"]]
	end
	return nil
end

--Returns true if Aspect of the Hawk is active
function SpellFlashAddon.isDragonhawkActive()
	return SpellFlashAddon.checkBuff((GetSpellInfo(61846))--[["Aspect of the Dragonhawk"]])
end

--Returns true if Aspect of the Hawk is active
function SpellFlashAddon.isViperActive()
	return SpellFlashAddon.checkBuff((GetSpellInfo(34074))--[["Aspect of the Viper"]])
end

--Returns true if Aspect of the Beast is active
function SpellFlashAddon.isBeastActive()
	return SpellFlashAddon.checkBuff((GetSpellInfo(13161))--[["Aspect of the Beast"]])
end

--Returns true if Aspect of the Hawk is active
function SpellFlashAddon.isHawkActive()
	return SpellFlashAddon.checkBuff((GetSpellInfo(13165))--[["Aspect of the Hawk"]])
end

--Returns true if Aspect of the Monkey is active
function SpellFlashAddon.isMonkeyActive()
	return SpellFlashAddon.checkBuff((GetSpellInfo(13163))--[["Aspect of the Monkey"]])
end

--Returns true if Aspect of the Cheetah is active
function SpellFlashAddon.isCheetahActive()
	return SpellFlashAddon.checkBuff((GetSpellInfo(5118))--[["Aspect of the Cheetah"]])
--  return SpellFlashAddon.checkBuff("JungleTiger")
end

--Returns true if Aspect of the Wild is active
function SpellFlashAddon.isWildActive()
	return SpellFlashAddon.checkBuff((GetSpellInfo(20043))--[["Aspect of the Wild"]],nil,1)
end

--Returns true if Aspect of the Cheetah is active
function SpellFlashAddon.isPackActive()
	return SpellFlashAddon.checkBuff((GetSpellInfo(13159))--[["Aspect of the Pack"]],nil,1)
end



--Returns true if Trueshot Aura is active
function SpellFlashAddon.isTrueshotActive(unit, mine)
	return SpellFlashAddon.checkBuff((GetSpellInfo(19506))--[["Trueshot Aura"]],unit,mine)
end

--Returns true if the hunter is currently feigned
function SpellFlashAddon.isFeignDeath()
	if UnitHealth("player") == 0 then
		return true
	end
	return false
end

--Returns true if Hunter Quickshots is active
function SpellFlashAddon.isQuickshotsActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"InnerRage")
end

--Returns true if Hunter Rapid Fire is active
function SpellFlashAddon.isRapidFireActive()
	return SpellFlashAddon.checkBuff((GetSpellInfo(3045))--[["Rapid Fire"]])
end



function SpellFlashAddon.Castable.ScareBeast()
	if ( UnitCreatureType("target") ~= "Beast" and not SpellFlashAddon.isDruid() ) or SpellFlashAddon.isCrowedControlled() then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(1513))--[["Scare Beast"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.SerpentSting()
	local z = {}
	z.SpellName = (GetSpellInfo(1978))--[["Serpent Sting"]]
	z.DebuffName = z.SpellName
	z.DebuffSlotNeeded = 1
	z.IsMine = 1
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.ViperSting()
	local z = {}
	z.SpellName = (GetSpellInfo(3034))--[["Viper Sting"]]
	z.DebuffName = z.SpellName
	z.DebuffSlotNeeded = 1
	z.IsMine = 1
	z.EnemyTargetNeeded = 1
	z.TargetThatUsesManaNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.ScorpidSting()
	local z = {}
	z.SpellName = (GetSpellInfo(3043))--[["Scorpid Sting"]]
	z.DebuffName = z.SpellName
	z.CheckDebuffRank = SpellFlashAddon.GetSpellRank(z.SpellName)
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.MongooseBite()
	local z = {}
	z.SpellName = (GetSpellInfo(1495))--[["Mongoose Bite"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.Counterattack()
	local z = {}
	z.SpellName = (GetSpellInfo(19306))--[["Counterattack"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.ConcussiveShot()
	if SpellFlashAddon.isMovementImpaired() then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(5116))--[["Concussive Shot"]]
	z.DebuffName = z.SpellName
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.RaptorStrike()
	if not SpellFlashAddon.HUNTER.MeleeDistance() then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(2973))--[["Raptor Strike"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.AspectOfTheDragonhawk()
	local z = {}
	z.SpellName = (GetSpellInfo(61846))--[["Aspect of the Dragonhawk"]]
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.AspectOfTheHawk()
	local z = {}
	z.SpellName = (GetSpellInfo(13165))--[["Aspect of the Hawk"]]
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.AspectOfTheViper()
	local z = {}
	z.SpellName = (GetSpellInfo(34074))--[["Aspect of the Viper"]]
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


function SpellFlashAddon.Castable.AspectOfTheWild()
	local z = {}
	z.SpellName = (GetSpellInfo(20043))--[["Aspect of the Wild"]]
	z.IsMine = 1
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.AspectOfTheBeast()
	local z = {}
	z.SpellName = (GetSpellInfo(13161))--[["Aspect of the Beast"]]
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.DistractingShot()
	local z = {}
	z.SpellName = (GetSpellInfo(20736))--[["Distracting Shot"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.ArcaneShot()
	local z = {}
	z.SpellName = (GetSpellInfo(3044))--[["Arcane Shot"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.Disengage()
	local z = {}
	z.SpellName = (GetSpellInfo(781))--[["Disengage"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.ScatterShot()
	if SpellFlashAddon.isCrowedControlled() then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(19503))--[["Scatter Shot"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.MultiShot()
	local z = {}
	z.SpellName = (GetSpellInfo(2643))--[["Multi-Shot"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.AimedShot()
	local z = {}
	z.SpellName = (GetSpellInfo(19434))--[["Aimed Shot"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


function SpellFlashAddon.Castable.HuntersMark()
	local z = {}
	z.SpellName = (GetSpellInfo(1130))--[["Hunter's Mark"]]
	z.DebuffName = z.SpellName
	z.CheckDebuffRank = SpellFlashAddon.GetSpellRank(z.SpellName)
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.AspectOfTheMonkey()
	local z = {}
	z.SpellName = (GetSpellInfo(13163))--[["Aspect of the Monkey"]]
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.FeignDeath()
	if SpellFlashAddon.isFeignDeath() then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(5384))--[["Feign Death"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.AspectOfTheCheetah()
	local z = {}
	z.SpellName = (GetSpellInfo(5118))--[["Aspect of the Cheetah"]]
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.AspectOfThePack()
	local z = {}
	z.SpellName = (GetSpellInfo(13159))--[["Aspect of the Pack"]]
	z.IsMine = 1
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.TrueshotAura()
	local z = {}
	z.SpellName = (GetSpellInfo(19506))--[["Trueshot Aura"]]
	z.IsMine = 1
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.BestialWrath()
	local z = {}
	z.SpellName = (GetSpellInfo(19574))--[["Bestial Wrath"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.Intimidation()
	if not UnitExists("pettarget") or SpellFlashAddon.isCrowedControlled("pettarget") then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(19577))--[["Intimidation"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.RapidFire()
	local z = {}
	z.SpellName = (GetSpellInfo(3045))--[["Rapid Fire"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.WingClip()
	local z = {}
	z.SpellName = (GetSpellInfo(2974))--[["Wing Clip"]]
	z.DebuffName = z.SpellName
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.WyvernSting()
	if SpellFlashAddon.isCrowedControlled() then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(19386))--[["Wyvern Sting"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.FreezingTrap()
	local z = {}
	z.SpellName = (GetSpellInfo(1499))--[["Freezing Trap"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.ImmolationTrap()
	local z = {}
	z.SpellName = (GetSpellInfo(13795))--[["Immolation Trap"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.FrostTrap()
	local z = {}
	z.SpellName = (GetSpellInfo(13809))--[["Frost Trap"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.ExplosiveTrap()
	local z = {}
	z.SpellName = (GetSpellInfo(13813))--[["Explosive Trap"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.MendPet()
	local z = {}
	z.SpellName = (GetSpellInfo(136))--[["Mend Pet"]]
	z.BuffName = z.SpellName
	z.BuffUnit = "pet"
	z.EvenIfCasting = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.MastersCall()
	local z = {}
	z.SpellName = (GetSpellInfo(53271))--[["Master's Call"]]
	z.EvenIfCasting = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.BlackArrow()
	local z = {}
	z.SpellName = (GetSpellInfo(3674))--[["Black Arrow"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.ExplosiveShot()
	local z = {}
	z.SpellName = (GetSpellInfo(53301))--[["Explosive Shot"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.KillShot()
	local z = {}
	z.SpellName = (GetSpellInfo(53351))--[["Kill Shot"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.SteadyShot()
	local z = {}
	z.SpellName = (GetSpellInfo(56641))--[["Steady Shot"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end




function SpellFlashAddon.HUNTER.MeleeDistance()
	local m =  (
		(GetSpellInfo((GetSpellInfo(2974))--[["Wing Clip"]])) or
		(GetSpellInfo((GetSpellInfo(1495))--[["Mongoose Bite"]])) or
		(GetSpellInfo((GetSpellInfo(19306))--[["Counterattack"]]))
	)
	if m then
		if IsSpellInRange(m,"target") ~= 1 then
			return false
		end
	elseif not CheckInteractDistance("target", 3) then
		return false
	end
	return true
end


