--------   All functions below this line will only load if you are playing the corresponding class   --------
if not SpellFlashAddon.MAGE then return end



function SpellFlashAddon.isArcaneIntellect(unit)
	local SpellName = (GetSpellInfo(1459))--[["Arcane Intellect"]]
	local unit = unit or "target"
	return SpellFlashAddon.checkBuff(SpellName, unit)
end









-- Added by Nosrac
function SpellFlashAddon.isArcaneIntellectActive()
	local SpellName = (GetSpellInfo(1459))--[["Arcane Intellect"]]
	return SpellFlashAddon.checkBuff(SpellName)
end

-- Added by Nosrac
function SpellFlashAddon.isFrostArmorActive()
	local SpellName = (GetSpellInfo(168))--[["Frost Armor"]]
	return SpellFlashAddon.checkBuff(SpellName)
end

-- Added by Nosrac
function SpellFlashAddon.isMageArmorActive()
	local SpellName = (GetSpellInfo(6117))--[["Mage Armor"]]
	return SpellFlashAddon.checkBuff(SpellName)
end

-- Added by Nosrac
function SpellFlashAddon.isArmorActive()
	if isFrostArmorActive() or isMageArmorActive() then
		return true
	end
	return false
end

-- Added by Nosrac
-- Will cast the spell if it is not on your target, if it is on your target or it can not be cast on your target, then it will cast on yourself if it is not on you.
function SpellFlashAddon.Castable.ArcaneIntellect()
	local SpellName = (GetSpellInfo(1459))--[["Arcane Intellect"]]
	local SpellButton = SpellFlashAddon.Button[SpellName]
	local friend = nil;
	if SpellButton then
		local isUsable, notEnoughMana = IsUsableSpell(SpellName)
		local _, duration, _ = GetSpellCooldown(SpellName)
		local inRange = IsSpellInRange(SpellName,"target")
		local isCurrent = IsCurrentSpell(SpellName)
		if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target") and ( isUsable == 1 ) and ( not notEnoughMana ) and ( duration == 0 ) and ( inRange == 1 ) and not ( isCurrent == 1 ) and (not isArcaneIntellect())) then
			UseAction(SpellButton)
			if SpellIsTargeting() then
				SpellStopTargeting()
				return false
			end
			return true
		elseif ( isUsable == 1 ) and ( not notEnoughMana ) and ( duration == 0 ) and not ( isCurrent == 1 ) and (not isArcaneIntellectActive()) then
			if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target")) then
				friend = 1;
				TargetUnit("player");
			end
			UseAction(SpellButton)
			if (friend) then
				TargetLastTarget();
			end
			if SpellIsTargeting() then
				if SpellCanTargetUnit("player") then
					SpellTargetUnit("player")
				else
					SpellStopTargeting()
					return false
				end
			end
			return true
		end
	elseif SpellFlashAddon.IsSpellKnown(SpellName) then
		SpellFlashAddon.debug(""..SpellName.." was not found on any of the action bars!")
		local SpellID = SpellFlashAddon.GetSpellID(SpellName)
		if not SpellFlashAddon.OnCooldown(SpellName) then
			if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target") and not isArcaneIntellect()) then
				CastSpell(SpellID, 0)
				if SpellIsTargeting() then
					SpellStopTargeting()
					return false
				end
				return true
			elseif (not isArcaneIntellectActive()) then
				if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target")) then
					friend = 1;
					TargetUnit("player");
				end
				CastSpell(SpellID, 0)
				if (friend) then
					TargetLastTarget();
				end
				if SpellIsTargeting() then
					if SpellCanTargetUnit("player") then
						SpellTargetUnit("player")
					else
						SpellStopTargeting()
						return false
					end
				end
				return true
			end
		end
	end
	return false
end

-- Will only cast the spell on your self if you do not have it on you and will not be able to cast on anything else.
function SpellFlashAddon.Castable.SelfArcaneIntellect()
	local SpellName = (GetSpellInfo(1459))--[["Arcane Intellect"]]
	local SpellButton = SpellFlashAddon.Button[SpellName]
	local friend = nil;
	if SpellButton then
		local isUsable, notEnoughMana = IsUsableSpell(SpellName)
		local _, duration, _ = GetSpellCooldown(SpellName)
		local isCurrent = IsCurrentSpell(SpellName)
		if ( isUsable == 1 ) and ( not notEnoughMana ) and ( duration == 0 ) and not ( isCurrent == 1 ) and (not isArcaneIntellectActive()) then
			if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target")) then
				friend = 1;
				TargetUnit("player");
			end
			UseAction(SpellButton)
			if (friend) then
				TargetLastTarget();
			end
			if SpellIsTargeting() then
				if SpellCanTargetUnit("player") then
					SpellTargetUnit("player")
				else
					SpellStopTargeting()
					return false
				end
			end
			return true
		end
	elseif SpellFlashAddon.IsSpellKnown(SpellName) then
		SpellFlashAddon.debug(""..SpellName.." was not found on any of the action bars!")
		local SpellID = SpellFlashAddon.GetSpellID(SpellName);
		if not SpellFlashAddon.OnCooldown(SpellName) then
			if (not isArcaneIntellectActive()) then
				if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target")) then
					friend = 1;
					TargetUnit("player");
				end
				CastSpell(SpellID, 0)
				if (friend) then
					TargetLastTarget();
				end
				if SpellIsTargeting() then
					if SpellCanTargetUnit("player") then
						SpellTargetUnit("player")
					else
						SpellStopTargeting()
						return false
					end
				end
				return true
			end
		end
	end
	return false
end








--Added By CodeMaster Rapture
function SpellFlashAddon.Castable.ArcaneExplosion(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.Test = test
	z.SpellName = (GetSpellInfo(1449))--[["Arcane Explosion"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By CodeMaster Rapture
function SpellFlashAddon.Castable.ArcaneMissiles(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.Test = test
	z.SpellName = (GetSpellInfo(5143))--[["Arcane Missiles"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By CodeMaster Rapture
function SpellFlashAddon.Castable.BlastWave(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.Test = test
	z.SpellName = (GetSpellInfo(11113))--[["Blast Wave"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By CodeMaster Rapture
function SpellFlashAddon.Castable.Blizzard(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.Test = test
	z.SpellName = (GetSpellInfo(10))--[["Blizzard"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By CodeMaster Rapture
function SpellFlashAddon.Castable.FireBlast(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.Test = test
	z.SpellName = (GetSpellInfo(2136))--[["Fire Blast"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By CodeMaster Rapture
function SpellFlashAddon.Castable.Fireball(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.Test = test
	z.SpellName = (GetSpellInfo(133))--[["Fireball"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By CodeMaster Rapture
function SpellFlashAddon.Castable.Flamestrike(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.Test = test
	z.SpellName = (GetSpellInfo(2120))--[["Flamestrike"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By CodeMaster Rapture
function SpellFlashAddon.Castable.Frostbolt(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.Test = test
	z.SpellName = (GetSpellInfo(116))--[["Frostbolt"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By CodeMaster Rapture
function SpellFlashAddon.Castable.Pyroblast(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.Test = test
	z.SpellName = (GetSpellInfo(11366))--[["Pyroblast"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By CodeMaster Rapture
function SpellFlashAddon.Castable.Scorch(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.Test = test
	z.SpellName = (GetSpellInfo(2948))--[["Scorch"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By CodeMaster Rapture
function SpellFlashAddon.isFrostArmorActive()
	local SpellName = (GetSpellInfo(168))--[["Frost Armor"]]
	return SpellFlashAddon.checkBuff(SpellName)
end

--Added By CodeMaster Rapture
function SpellFlashAddon.isIceArmorActive()
	local SpellName = (GetSpellInfo(7302))--[["Ice Armor"]]
	return SpellFlashAddon.checkBuff(SpellName)
end

--Added By CodeMaster Rapture
function SpellFlashAddon.isMageArmorActive()
	local SpellName = (GetSpellInfo(6117))--[["Mage Armor"]]
	return SpellFlashAddon.checkBuff(SpellName)
end

--Added By CodeMaster Rapture
--Casts Frost/Ice Armor if it is not active
function SpellFlashAddon.Castable.IceArmor(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.Test = test
	z.SpellName = (GetSpellInfo(7302))--[["Ice Armor"]]
	z.EnemyTargetNotNeeded = 1
	z.BuffName = z.SpellName

	if not SpellFlashAddon.Button[z.SpellName] then
		if not SpellFlashAddon.IsSpellKnown(z.SpellName) then
			z.SpellName = (GetSpellInfo(168))--[["Frost Armor"]]
			z.BuffName = z.SpellName
		else
			z.SpellCheckNotNeeded = 1
		end
	end

	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By CodeMaster Rapture
--Casts Mage Armor if it is not active
function SpellFlashAddon.Castable.MageArmor(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.Test = test
	z.SpellName = (GetSpellInfo(6117))--[["Mage Armor"]]
	z.EnemyTargetNotNeeded = 1
	z.BuffName = z.SpellName

	return SpellFlashAddon.CheckIfSpellCastable(z)
end



