

function SpellFlashAddon.Castable.Attack()
	if SpellFlashAddon[SpellFlashAddon.CLASS].MeleeDistance then
		if not SpellFlashAddon[SpellFlashAddon.CLASS].MeleeDistance() then
			return false
		end
	elseif not CheckInteractDistance("target", 3) then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(6603))--[["Attack"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end




function SpellFlashAddon.isSelfPoisoned()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,"Poison")
end

function SpellFlashAddon.isSelfDiseased()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,"Disease")
end





function SpellFlashAddon.isTrackingTexture(texture)
	if GetTrackingTexture() and string.find(GetTrackingTexture(), texture) then
		return true
	end
	return false
end

function SpellFlashAddon.isTrackingActive()
	if GetTrackingTexture() then
		return true
	end
	return false
end

function SpellFlashAddon.isTrackHumanoidsActive()
	return SpellFlashAddon.isTrackingTexture("Spell_Holy_PrayerOfHealing")
end

function SpellFlashAddon.isTrackMineralsActive()
	return SpellFlashAddon.isTrackingTexture("Spell_Nature_Earthquake")
end

function SpellFlashAddon.isTrackBeastsActive()
	return SpellFlashAddon.isTrackingTexture("Ability_Tracking")
end

function SpellFlashAddon.isTrackDemonsActive()
	return SpellFlashAddon.isTrackingTexture("Spell_Shadow_SummonFelHunter")
end

function SpellFlashAddon.isTrackDragonsActive()
	return SpellFlashAddon.isTrackingTexture("INV_Misc_Head_Dragon_01")
end

function SpellFlashAddon.isTrackElementalsActive()
	return SpellFlashAddon.isTrackingTexture("Spell_Frost_SummonWaterElemental")
end

function SpellFlashAddon.isTrackGiantsActive()
	return SpellFlashAddon.isTrackingTexture("Ability_Racial_Avatar")
end

function SpellFlashAddon.isTrackHiddenActive()
	return SpellFlashAddon.isTrackingTexture("Ability_Stealth")
end

function SpellFlashAddon.isTrackUndeadActive()
	return SpellFlashAddon.isTrackingTexture("Spell_Shadow_DarkSummoning")
end

function SpellFlashAddon.isTrackHerbsActive()
	return SpellFlashAddon.isTrackingTexture("INV_Misc_Flower_02")
end




-- Added by Corpboy
function SpellFlashAddon.isBeast(unit)
	if UnitCreatureType(unit or "target") == "Beast" then
		return true
	end
	return false
end

-- Added by Corpboy
function SpellFlashAddon.isHumanoid(unit)
	if UnitCreatureType(unit or "target") == "Humanoid" then
		return true
	end
	return false
end

-- Added by Corpboy
function SpellFlashAddon.isUndead(unit)
	if UnitCreatureType(unit or "target") == "Undead" then
		return true
	end
	return false
end

-- Added by Corpboy
function SpellFlashAddon.isElemental(unit)
	if UnitCreatureType(unit or "target") == "Elemental" then
		return true
	end
	return false
end

-- Added by Corpboy
function SpellFlashAddon.isDemon(unit)
	if UnitCreatureType(unit or "target") == "Demon" then
		return true
	end
	return false
end

-- Added by Corpboy
function SpellFlashAddon.isGiant(unit)
	if UnitCreatureType(unit or "target") == "Giant" then
		return true
	end
	return false
end

-- Added by Corpboy
function SpellFlashAddon.isDragonkin(unit)
	if UnitCreatureType(unit or "target") == "Dragonkin" then
		return true
	end
	return false
end



-- Added by Corpboy
function SpellFlashAddon.Castable.TrackBeasts()
	if SpellFlashAddon.isTrackBeastsActive() then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(1494))--[["Track Beasts"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

-- Added by Corpboy
function SpellFlashAddon.Castable.TrackHumanoids()
	if SpellFlashAddon.isTrackHumanoidsActive() then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(19883))--[["Track Humanoids"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

-- Added by Corpboy
function SpellFlashAddon.Castable.TrackUndead()
	if SpellFlashAddon.isTrackUndeadActive() then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(19884))--[["Track Undead"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

-- Added by Corpboy
function SpellFlashAddon.Castable.TrackElementals()
	if SpellFlashAddon.isTrackElementalsActive() then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(19880))--[["Track Elementals"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

-- Added by Corpboy
function SpellFlashAddon.Castable.TrackGiants()
	if SpellFlashAddon.isTrackGiantsActive() then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(19882))--[["Track Giants"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

-- Added by Corpboy
function SpellFlashAddon.Castable.TrackDragonkin()
	if SpellFlashAddon.isTrackDragonkinActive() then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(19879))--[["Track Dragonkin"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end



function SpellFlashAddon.isEatingActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Fork&Knife")
end

function SpellFlashAddon.isDrinkingActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Drink")
end


--Returns true if shadow meld is activated
--Written by Malnyth of Ravencrest
function SpellFlashAddon.isShadowMeld()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Ambush")
end

function SpellFlashAddon.Castable.Shadowmeld()
	local SpellName = (GetSpellInfo(58984))--[["Shadowmeld"]]
	local FeignSpellName = (GetSpellInfo(5384))--[["Feign Death"]]
	local q = 80
	if SpellFlashAddon.IsSpellKnown(SpellName) and not SpellFlashAddon.isMeld() then
		local SpellID = SpellFlashAddon.GetSpellID(SpellName)
		if not SpellFlashAddon.OnCooldown(SpellName) then
			if SpellFlashAddon.HUNTER and SpellFlashAddon.notInCombat() then
				q = 0
			end
			if not SpellFlashAddon.HUNTER or (UnitMana("player") >= q) or (UnitHealth("player") == 0) then
				if SpellFlashAddon.notInCombat() then
					CastSpell(SpellID, 0)
					return true
				else
					if SpellFlashAddon.HUNTER and SpellFlashAddon.IsSpellKnown(FeignSpellName) then
						local FeignSpellID = SpellFlashAddon.GetSpellID(FeignSpellName)
						if not SpellFlashAddon.OnCooldown(FeignSpellName) and not SpellFlashAddon.isFeign() then
							CastSpell(FeignSpellID, 0)
							if UnitExists("pettarget") then
								PetFollow()
								PetPassiveMode()
							end
							return true
						end
					end
				end
			end
		end
	end
	return false
end

function SpellFlashAddon.Castable.Stoneform()
	local z = {}
	z.SpellName = (GetSpellInfo(20594))--[["Stoneform"]]
	z.EnemyTargetNotNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.Berserking()
	local z = {}
	z.SpellName = (GetSpellInfo(20554))--[["Berserking"]]
	z.EnemyTargetNotNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.WillOfTheForsaken()
	local z = {}
	z.SpellName = (GetSpellInfo(7744))--[["Will of the Forsaken"]]
	z.EnemyTargetNotNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.Shoot()
	if SpellFlashAddon.AutoShoot then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(3018))--[["Shoot"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


