--------   All functions below this line will only load if you are playing the corresponding class   --------
if not SpellFlashAddon.PRIEST then return end





--Returns true if target has Renew on
function SpellFlashAddon.isRenew(unit, castable)
	unit = unit or "target"
	return SpellFlashAddon.checkBuff(nil,unit,nil,nil,nil,nil,castable,"Spell_Holy_Renew")
end

--Made By Despised
--Returns true if Shadow Word Pain is on target
function SpellFlashAddon.isShadowWordPain(unit, dispelable)
	return SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,dispelable,"Shadow_ShadowWordPain")
end

--Added by Devla
function SpellFlashAddon.isHolyFire(unit, dispelable)
	return SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,dispelable,"Spell_Holy_SearingLight")
end

--Added by Devla
function SpellFlashAddon.isMindControl(unit, dispelable)
	return SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,dispelable,"Shadow_ShadowWordDominate")
end

--Added by Devla
function SpellFlashAddon.isMindFlay(unit, dispelable)
	return SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,dispelable,"Spell_Shadow_SiphonMana")
end

--Added by Devla
function SpellFlashAddon.isShackle(unit, dispelable)
	return SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,dispelable,"Spell_Nature_Slow")
end

--Added by Devla
function SpellFlashAddon.isTouchOfWeakness(unit, dispelable)
	return SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,dispelable,"Spell_Shadow_DeadofNight")
end

--Added by Devla
function SpellFlashAddon.isHexOfWeakness(unit, dispelable)
	return SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,dispelable,"Spell_Shadow_FingerOfDeath")
end


--Returns true if target has Power Word: Fortitude on
function SpellFlashAddon.isPowerWordFortitude(unit, castable)
	unit = unit or "target"
	return SpellFlashAddon.checkBuff(nil,unit,nil,nil,nil,nil,castable,"Holy_WordFortitude")
end




--Returns true if Devouring Plague is on target
function SpellFlashAddon.isDevouringPlague(unit, dispelable)
	return SpellFlashAddon.checkDebuff((GetSpellInfo(spellid))--[["Devouring Plague"]],unit,nil,nil,nil,nil,dispelable)
end

-- Added by Melancholia
function SpellFlashAddon.isVampiricEmbrace(unit, dispelable)
	return SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,dispelable,"Spell_Shadow_UnsummonBuilding")
end

--Added by Melancholia
--Returns true if target has Power Word: Shield on
function SpellFlashAddon.isPowerWordShield(unit, castable)
	unit = unit or "target"
	return SpellFlashAddon.checkBuff(nil,unit,nil,nil,nil,nil,castable,"Holy_PowerWordShield")
end

--Added by BigRedBrent
--Debuff
function SpellFlashAddon.isWeakenedSoul(unit, dispelable)
	return SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,dispelable,"Spell_Holy_AshesToAshes")
end














--Made By Despised
--Returns true if player has Inner Fire on
function SpellFlashAddon.isInnerFireActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Holy_InnerFire")
end

--Made By Despised
--Returns true if player has Power Word: Fortitude on
function SpellFlashAddon.isPowerWordFortitudeActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Holy_WordFortitude")
end


function SpellFlashAddon.Castable.PsychicScream(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(spellid))--[["Psychic Scream"]]
	z.NoRangeCheck = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Made By Despised
--Casts Shadow Word Pain on Target if its not active already
function SpellFlashAddon.Castable.ShadowWordPain(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(spellid))--[["Shadow Word Pain"]]
	z.DebuffName = z.SpellName
	z.IsMine = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By Devla
--Casts Holy Fire on Target if its not active already
function SpellFlashAddon.Castable.HolyFire(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(spellid))--[["Holy Fire"]]
	z.DebuffName = z.SpellName
	z.IsMine = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By Devla
--Casts Mind Control on Target if its not active already
function SpellFlashAddon.Castable.MindControl(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(spellid))--[["Mind Control"]]
	z.DebuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By Devla
--Casts Mind Flay on Target if its not active already
function SpellFlashAddon.Castable.MindFlay(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(spellid))--[["Mind Flay"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By Devla
--Casts Shackle Undead on Target if the target is not already cc'ed
function SpellFlashAddon.Castable.Shackle()
	if UnitCreatureType("target") ~= "Undead" or SpellFlashAddon.isNoDamageCC() then
		return false
	end
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(spellid))--[["Shackle Undead"]]
	z.DebuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By Devla
--Casts Touch of Weakness on Target if its not active already
function SpellFlashAddon.Castable.TouchOfWeakness(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(spellid))--[["Touch of Weakness"]]
	z.DebuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added By Devla
--Casts Hex of Weakness on Target if its not active already
function SpellFlashAddon.Castable.HexOfWeakness(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(spellid))--[["Hex of Weakness"]]
	z.DebuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Made by Despised
--Casts Inner Fire if it is not active
function SpellFlashAddon.Castable.InnerFire(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(spellid))--[["Inner Fire"]]
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by Rackartussen
function SpellFlashAddon.Castable.Shadowguard(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(spellid))--[["Shadowguard"]]
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


-- Will cast the spell on an enemy target if one is targeted.
--If you have no target it will cast on yourself if a debuff is on you that can be dispeled. If you have a friend targeted it will cast on them if they have a debuff on them that can be dispeled.
function SpellFlashAddon.Castable.DispelMagic()
	local SpellName = (GetSpellInfo(spellid))--[["Dispel Magic"]]
	local SpellButton = SpellFlashAddon.Button[SpellName]
	if SpellButton then
		local isUsable, notEnoughMana = IsUsableSpell(SpellName)
		local _, duration, _ = GetSpellCooldown(SpellName)
		local inRange = IsSpellInRange(SpellName,"target")
		local isCurrent = IsCurrentSpell(SpellName)
		if ( isUsable == 1 ) and ( not notEnoughMana ) and ( duration == 0 ) and ( isCurrent ~= 1 ) then
			if (( inRange == 1 ) and UnitIsFriend("player", "target") and SpellFlashAddon.checkDebuff(nil,nil,nil,nil,nil,nil,"dispelable")) or (not UnitExists("target") and SpellFlashAddon.checkDebuff(nil,"player",nil,nil,nil,nil,"dispelable")) then
				UseAction(SpellButton)
				if (SpellIsTargeting() and SpellCanTargetUnit("player")) then
					SpellTargetUnit("player");
				elseif SpellIsTargeting() then
					SpellStopTargeting()
					return false
				end
				return true
			elseif UnitExists("target") and SpellFlashAddon.checkDebuff(nil,"player",nil,nil,nil,nil,"dispelable") then
				TargetUnit("player");
				UseAction(SpellButton)
				TargetLastTarget();
				return true
			elseif ( inRange == 1 ) and SpellFlashAddon.TargetIsEnemy() then
				UseAction(SpellButton)
				return true
			end
		end
	elseif SpellFlashAddon.IsSpellKnown(SpellName) then
		SpellFlashAddon.debug(""..SpellName.." was not found on any of the action bars!")
		local SpellID = SpellFlashAddon.GetSpellID(SpellName);
		if not SpellFlashAddon.OnCooldown(SpellName) then
			if (UnitIsFriend("player", "target") and SpellFlashAddon.checkDebuff(nil,nil,nil,nil,nil,nil,"dispelable")) or (not UnitExists("target") and SpellFlashAddon.checkDebuff(nil,"player",nil,nil,nil,nil,"dispelable")) then
				CastSpell(SpellID, 0)
				if (SpellIsTargeting() and SpellCanTargetUnit("player")) then
					SpellTargetUnit("player");
				elseif SpellIsTargeting() then
					SpellStopTargeting()
					return false
				end
				return true
			elseif UnitExists("target") and SpellFlashAddon.checkDebuff(nil,"player",nil,nil,nil,nil,"dispelable") then
				TargetUnit("player");
				CastSpell(SpellID, 0)
				TargetLastTarget();
				return true
			elseif SpellFlashAddon.TargetIsEnemy() then
				CastSpell(SpellID, 0)
				return true
			end
		end
	end
	return false
end





-- Will cast the spell if it is not on your target, if it is on your target or it can not be cast on your target, then it will cast on yourself if it is not on you.
function SpellFlashAddon.Castable.PowerWordFortitude()
	local SpellName = (GetSpellInfo(spellid))--[["Power Word Fortitude"]]
	local SpellButton = SpellFlashAddon.Button[SpellName]
	local friend = nil;
	if SpellButton then
		local isUsable, notEnoughMana = IsUsableSpell(SpellName)
		local _, duration, _ = GetSpellCooldown(SpellName)
		local inRange = IsSpellInRange(SpellName,"target")
		local isCurrent = IsCurrentSpell(SpellName)
		if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target") and ( isUsable == 1 ) and ( not notEnoughMana ) and ( duration == 0 ) and ( inRange == 1 ) and ( isCurrent ~= 1 ) and (not isPowerWordFortitude())) then
			UseAction(SpellButton)
			if SpellIsTargeting() then
				SpellStopTargeting()
				return false
			end
			return true
		elseif ( isUsable == 1 ) and ( not notEnoughMana ) and ( duration == 0 ) and ( isCurrent ~= 1 ) and (not isPowerWordFortitudeActive()) then
			if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target")) then
				friend = 1;
				TargetUnit("player");
			end
			UseAction(SpellButton)
			if (friend) then
				TargetLastTarget();
			end
			if (SpellIsTargeting() and SpellCanTargetUnit("player")) then
				SpellTargetUnit("player");
			elseif SpellIsTargeting() then
				SpellStopTargeting()
				return false
			end
			return true
		end
	elseif SpellFlashAddon.IsSpellKnown(SpellName) then
		SpellFlashAddon.debug(""..SpellName.." was not found on any of the action bars!")
		local SpellID = SpellFlashAddon.GetSpellID(SpellName)
		if not SpellFlashAddon.OnCooldown(SpellName) then
			if (UnitIsFriend("player", "target") and not UnitIsUnit("player", "target") and not isPowerWordFortitude()) then
				CastSpell(SpellID, 0)
				if SpellIsTargeting() then
					SpellStopTargeting()
					return false
				end
				return true
			elseif (not isPowerWordFortitudeActive()) then
				if (UnitIsFriend("player", "target") and not UnitIsUnit("player", "target")) then
					friend = 1;
					TargetUnit("player");
				end
				CastSpell(SpellID, 0)
				if (friend) then
					TargetLastTarget();
				end
				if (SpellIsTargeting() and SpellCanTargetUnit("player")) then
					SpellTargetUnit("player");
				elseif SpellIsTargeting() then
					SpellStopTargeting()
					return false
				end
				return true
			end
		end
	end
	return false
end


-- Will cast the spell if it is not on your target, if it is on your target or it can not be cast on your target, then it will cast on yourself if it is not on you.
function SpellFlashAddon.Castable.Renew()
	local SpellName = (GetSpellInfo(spellid))--[["Renew"]]
	local SpellButton = SpellFlashAddon.Button[SpellName]
	local friend = nil;
	if SpellButton then
		local isUsable, notEnoughMana = IsUsableSpell(SpellName)
		local _, duration, _ = GetSpellCooldown(SpellName)
		local inRange = IsSpellInRange(SpellName,"target")
		local isCurrent = IsCurrentSpell(SpellName)
		if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target") and ( isUsable == 1 ) and ( not notEnoughMana ) and ( duration == 0 ) and ( inRange == 1 ) and ( isCurrent ~= 1 ) and (not isRenew())) then
			UseAction(SpellButton)
			if SpellIsTargeting() then
				SpellStopTargeting()
				return false
			end
			return true
		elseif ( isUsable == 1 ) and ( not notEnoughMana ) and ( duration == 0 ) and ( isCurrent ~= 1 ) and (not UnitExists("target") or not UnitIsFriend("player", "target")) and (not isRenew("player")) then
			if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target")) then
				friend = 1;
				TargetUnit("player");
			end
			UseAction(SpellButton)
			if (friend) then
				TargetLastTarget();
			end
			if (SpellIsTargeting() and SpellCanTargetUnit("player")) then
				SpellTargetUnit("player");
			elseif SpellIsTargeting() then
				SpellStopTargeting()
				return false
			end
			return true
		end
	elseif SpellFlashAddon.IsSpellKnown(SpellName) then
		SpellFlashAddon.debug(""..SpellName.." was not found on any of the action bars!")
		local SpellID = SpellFlashAddon.GetSpellID(SpellName)
		if not SpellFlashAddon.OnCooldown(SpellName) then
			if (UnitIsFriend("player", "target") and not UnitIsUnit("player", "target") and not isRenew()) then
				CastSpell(SpellID, 0)
				if SpellIsTargeting() then
					SpellStopTargeting()
					return false
				end
				return true
			elseif (not UnitExists("target") or not UnitIsFriend("player", "target")) and (not isRenew("player")) then
				if (UnitIsFriend("player", "target") and not UnitIsUnit("player", "target")) then
					friend = 1;
					TargetUnit("player");
				end
				CastSpell(SpellID, 0)
				if (friend) then
					TargetLastTarget();
				end
				if (SpellIsTargeting() and SpellCanTargetUnit("player")) then
					SpellTargetUnit("player");
				elseif SpellIsTargeting() then
					SpellStopTargeting()
					return false
				end
				return true
			end
		end
	end
	return false
end


--Made by Despised
--Casts Devouring Plague(undead priest spell) if cooldown is up
function SpellFlashAddon.Castable.DevouringPlague(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(spellid))--[["Devouring Plague"]]
	z.IsMine = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


--Made By Despised
--Casts Mind Blast if cooldown is up
function SpellFlashAddon.Castable.MindBlast(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(spellid))--[["Mind Blast"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Made By Guylien
--Casts Smite if cooldown is up
function SpellFlashAddon.Castable.Smite(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(spellid))--[["Smite"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end



-- Added by Melancholia
--Casts Vamperic Embrace on Target if its not active already
function SpellFlashAddon.Castable.VampiricEmbrace(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(spellid))--[["Vampiric Embrace"]]
	z.DebuffName = z.SpellName
	z.IsMine = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by Melancholia
--Returns true if player has Power Word: Shield on
function SpellFlashAddon.isPowerWordShieldActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Holy_PowerWordShield")
end



--Added by Melancholia
-- Will cast the spell if it is not on your target, if it is on your target or it can not be cast on your target, then it will cast on yourself if it is not on you.
function SpellFlashAddon.Castable.PowerWordShield()
	local SpellName = (GetSpellInfo(spellid))--[["Power Word Shield"]]
	local SpellButton = SpellFlashAddon.Button[SpellName]
	local friend = nil;
	if SpellButton then
		local isUsable, notEnoughMana = IsUsableSpell(SpellName)
		local _, duration, _ = GetSpellCooldown(SpellName)
		local inRange = IsSpellInRange(SpellName,"target")
		local isCurrent = IsCurrentSpell(SpellName)
		if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target") and ( isUsable == 1 ) and ( not notEnoughMana ) and ( duration == 0 ) and ( inRange == 1 ) and ( isCurrent ~= 1 ) and (not isWeakenedSoul()) and (not isPowerWordShield())) then
			UseAction(SpellButton)
			if SpellIsTargeting() then
				SpellStopTargeting()
				return false
			end
			return true
		elseif ( isUsable == 1 ) and ( not notEnoughMana ) and ( duration == 0 ) and ( isCurrent ~= 1 ) and (not isWeakenedSoul("player")) and (not isPowerWordShieldActive()) then
			if (UnitIsFriend("player", "target") and not UnitIsUnit("player","target")) then
				friend = 1;
				TargetUnit("player");
			end
			UseAction(SpellButton)
			if (friend) then
				TargetLastTarget();
			end
			if (SpellIsTargeting() and SpellCanTargetUnit("player")) then
				SpellTargetUnit("player");
			elseif SpellIsTargeting() then
				SpellStopTargeting()
				return false
			end
			return true
		end
	elseif SpellFlashAddon.IsSpellKnown(SpellName) then
		SpellFlashAddon.debug(""..SpellName.." was not found on any of the action bars!")
		local SpellID = SpellFlashAddon.GetSpellID(SpellName)
		if not SpellFlashAddon.OnCooldown(SpellName) then
			if (UnitIsFriend("player", "target") and not UnitIsUnit("player", "target") and not isWeakenedSoul() and not isPowerWordShield()) then
				CastSpell(SpellID, 0)
				if SpellIsTargeting() then
					SpellStopTargeting()
					return false
				end
				return true
			elseif (not isWeakenedSoul("player")) and (not isPowerWordShieldActive()) then
				if (UnitIsFriend("player", "target") and not UnitIsUnit("player", "target")) then
					friend = 1;
					TargetUnit("player");
				end
				CastSpell(SpellID, 0)
				if (friend) then
					TargetLastTarget();
				end
				if (SpellIsTargeting() and SpellCanTargetUnit("player")) then
					SpellTargetUnit("player");
				elseif SpellIsTargeting() then
					SpellStopTargeting()
					return false
				end
				return true
			end
		end
	end
	return false
end





-- From: Jiral
function SpellFlashAddon.Castable.LesserHeal(Mode, RankAdj, unit)
	local SpellName = (GetSpellInfo(spellid))--[["Lesser Heal"]]
	local SpellButton = SpellFlashAddon.Button[SpellName]
	local LevelLearnedArray={1,4,10}
	local ManaArray={35,50,85}
	local MinHealArray={46,71,135}
	local MaxHealArray={56,85,157}
	local TimeArray={1.5,2,2.5}
	return SpellFlashAddon.CastHealingSpell(SpellName, ManaArray, MinHealArray, MaxHealArray, TimeArray, LevelLearnedArray, Mode, RankAdj, unit, SpellButton)
end

-- From: Jiral
function SpellFlashAddon.Castable.Heal(Mode, RankAdj, unit)
	local SpellName = (GetSpellInfo(spellid))--[["Heal"]]
	local SpellButton = SpellFlashAddon.Button[SpellName]
	local LevelLearnedArray={16,22,28,34}
	local ManaArray={170,265,375,450}
	local MinHealArray={295,499,754,948}
	local MaxHealArray={341,571,856,1072}
	local TimeArray={3,3.5,4,4}
	return SpellFlashAddon.CastHealingSpell(SpellName, ManaArray, MinHealArray, MaxHealArray, TimeArray, LevelLearnedArray, Mode, RankAdj, unit, SpellButton)
end

-- From: Jiral
function SpellFlashAddon.Castable.GreaterHeal(Mode, RankAdj, unit)
	local SpellName = (GetSpellInfo(spellid))--[["Greater Heal"]]
	local SpellButton = SpellFlashAddon.Button[SpellName]
	local LevelLearnedArray={40,46,52,58,60}
	local ManaArray={545,665,800,960,1040}
	local MinHealArray={1201,1531,1919,2396,2618}
	local MaxHealArray={1353,1717,2147,2674,2922}
	local TimeArray={4,4,4,4,4}
	return SpellFlashAddon.CastHealingSpell(SpellName, ManaArray, MinHealArray, MaxHealArray, TimeArray, LevelLearnedArray, Mode, RankAdj, unit, SpellButton)
end





-- Added by Bam
function SpellFlashAddon.Castable.FlashHeal(Mode, RankAdj, unit)
  local SpellName = (GetSpellInfo(spellid))--[["Flash Heal"]]
  local SpellButton = SpellFlashAddon.Button[SpellName]
  local LevelLearnedArray={20,26,32,38,44,50,56}
  local ManaArray={125,155,185,215,265,315,380}
  local MinHealArray={196,258,327,400,518,644,812}
  local MaxHealArray={241,314,393,478,616,764,958}
  local TimeArray={1.5,1.5,1.5,1.5,1.5,1.5,1.5}
  return SpellFlashAddon.CastHealingSpell(SpellName, ManaArray, MinHealArray, MaxHealArray, TimeArray, LevelLearnedArray, Mode, RankAdj, unit, SpellButton)
end


