--------   All functions below this line will only load if you are playing the corresponding class   --------
if not SpellFlashAddon.ROGUE then return end





function SpellFlashAddon.isComboPointsFull()
	return isComboPoints(5)
end

function SpellFlashAddon.isComboPoints(number)
	if number then
		if GetComboPoints() >= number then
			return true
		end
	elseif GetComboPoints() > 0 then
		return true
	end
	return false
end


--Added by charroux
function SpellFlashAddon.isHemorrhage(unit)
	return SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,nil,"Spell_Shadow_LifeDrain")
end











function SpellFlashAddon.isStealthActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Ability_Stealth")
end

function SpellFlashAddon.isSliceActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Ability_Rogue_SliceDice")
end 

--Added by Nosrac
function SpellFlashAddon.isAdrenalineRushActive()
	return SpellFlashAddon.checkBuff((GetSpellInfo(spellid))--[["Adrenaline Rush"]])
end

--Added by Nosrac
function SpellFlashAddon.isBladeFlurryActive()
	return SpellFlashAddon.checkBuff((GetSpellInfo(spellid))--[["Blade Flurry"]])
end

--Added by Nosrac
function SpellFlashAddon.isEvasionActive()
	return SpellFlashAddon.checkBuff((GetSpellInfo(spellid))--[["Evasion"]])
end

--Added by Nosrac
function SpellFlashAddon.isSprintActive()
	return SpellFlashAddon.checkBuff((GetSpellInfo(spellid))--[["Sprint"]])
end


--Added by Nosrac
function SpellFlashAddon.isCripplingPoisonActive(hand)
	return SpellFlashAddon.checkHandItemBuff((GetSpellInfo(spellid))--[["Crippling Poison"]], hand)
end

--Added by Nosrac
function SpellFlashAddon.isDeadlyPoisonActive(hand)
	return SpellFlashAddon.checkHandItemBuff((GetSpellInfo(spellid))--[["Deadly Poison"]], hand)
end

--Added by Nosrac
function SpellFlashAddon.isInstantPoisonActive(hand)
	return SpellFlashAddon.checkHandItemBuff((GetSpellInfo(spellid))--[["Instant Poison"]], hand)
end

--Added by Nosrac
function SpellFlashAddon.isMindnumbingPoisonActive(hand)
	return SpellFlashAddon.checkHandItemBuff((GetSpellInfo(spellid))--[["Mindnumbing Poison"]], hand)
end

--Added by Nosrac
function SpellFlashAddon.isWoundPoisonActive(hand)
	return SpellFlashAddon.checkHandItemBuff((GetSpellInfo(spellid))--[["Wound Poison"]], hand)
end

--Added by BigRedBrent
function SpellFlashAddon.isPoisonActive(hand)
	if SpellFlashAddon.isCripplingPoisonActive(hand) or SpellFlashAddon.isDeadlyPoisonActive(hand) or SpellFlashAddon.isInstantPoisonActive(hand) or SpellFlashAddon.isMindnumbingPoisonActive(hand) or SpellFlashAddon.isWoundPoisonActive(hand) then
		return true
	end
	return false
end

-- Returns the energy cost the Cheap Shot ability will need for it to cast (even if talent points are spent on it to lower its required energy cost).
-- Will return 0 if no rank of the ability has been learned from the Rouge Trainer.
function SpellFlashAddon.CheapShotEnergyCost()
	if SpellFlashAddon.IsSpellKnown((GetSpellInfo(spellid))--[["Cheap Shot"]]) then
		local t = SpellFlashAddon.GetTalentRank((GetSpellInfo(spellid))--[["Dirty Deeds"]])
		return (60 - (10 * t))
	end
	return 0
end

-- Returns the energy cost the Garrote ability will need for it to cast (even if talent points are spent on it to lower its required energy cost).
-- Will return 0 if no rank of the ability has been learned from the Rouge Trainer.
function SpellFlashAddon.GarroteEnergyCost()
	if SpellFlashAddon.IsSpellKnown((GetSpellInfo(spellid))--[["Garrote"]]) then
		local t = SpellFlashAddon.GetTalentRank((GetSpellInfo(spellid))--[["Dirty Deeds"]])
		return (50 - (10 * t))
	end
	return 0
end



-- Returns the energy cost the Sinister Strike ability will need for it to cast (even if talent points are spent on it to lower its required energy cost).
-- Will return 0 if no rank of the ability has been learned from the Rouge Trainer.
function SpellFlashAddon.SinisterStrikeEnergyCost()
	if SpellFlashAddon.IsSpellKnown((GetSpellInfo(spellid))--[["Sinister Strike"]]) then
		local t = SpellFlashAddon.GetTalentRank((GetSpellInfo(spellid))--[["Improved Sinister Strike"]])
		if t == 2 then
			return 40
		elseif t == 1 then
			return 42
		end
		return 45
	end
	return 0
end



function SpellFlashAddon.Castable.SinisterStrike()
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Sinister Strike"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end



function SpellFlashAddon.Castable.CheapShot()
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Cheap Shot"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


function SpellFlashAddon.Castable.Garrote()
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Garrote"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end



function SpellFlashAddon.Castable.Backstab()
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Backstab"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end



function SpellFlashAddon.Castable.Kick()
	if not SpellFlashAddon.isCastingOrChanneling(nil,nil,"target") then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Kick"]]
	z.EnemyTargetNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end



--Added by Mainline
function SpellFlashAddon.Castable.ColdBlood()
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Cold Blood"]]
	z.EnemyTargetNotNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end





--Added by Xek
function SpellFlashAddon.Castable.Eviscerate(ComboPointsNumber)
	if not SpellFlashAddon.isComboPoints(ComboPointsNumber) then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Eviscerate"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by Xek
function SpellFlashAddon.Castable.Riposte()
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Riposte"]]
	z.ManaNeeded = 10
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by Xek
function SpellFlashAddon.Castable.SliceAndDice()
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Slice and Dice"]]
	z.ManaNeeded = 25
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by charroux
--Edited by BigRedBrent
function SpellFlashAddon.Castable.Hemorrhage(RemoveDebuffCheck)
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Hemorrhage"]]
	if not RemoveDebuffCheck then
		z.DebuffName = z.SpellName
	end
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by charroux
function SpellFlashAddon.Castable.GhostlyStrike()
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Ghostly Strike"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.Stealth()
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Stealth"]]
	z.BuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function unStealth()
	return SpellFlashAddon.CancelSelfBuff("Ability_Stealth")
end

function SpellFlashAddon.Castable.Vanish()
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Vanish"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by charroux
function SpellFlashAddon.Castable.Ambush()
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Ambush"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by charroux
function SpellFlashAddon.Castable.KidneyShot(ComboPointsNumber)
	if not SpellFlashAddon.isComboPoints(ComboPointsNumber) then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Kidney Shot"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by charroux
function SpellFlashAddon.Castable.BladeFlurry()
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Blade Flurry"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by charroux
function SpellFlashAddon.Castable.Gouge()
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Gouge"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


function SpellFlashAddon.Castable.Feint(GroupOnly)
	if GroupOnly then
		local raid = UnitInRaid("player")
		if (not raid and GetNumPartyMembers() == 0) or (raid and GetNumRaidMembers() <= 1) then
			return false
		end
	end
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Feint"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--Added by charroux
function SpellFlashAddon.Castable.Blind(RequiredPowderReserve)
	if SpellFlashAddon.GiveContainerItemCountByItemID(5530) <= (RequiredPowderReserve or 0) then
		return false
	end
	local z = {}
	z.SpellName = (GetSpellInfo(spellid))--[["Blind"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end



