--------   All functions below this line will only load if you are playing the corresponding class   --------
if not SpellFlashAddon.WARLOCK then return end





function SpellFlashAddon.WARLOCK.OnEvent(event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20)

	if event == "ACTIONBAR_HIDEGRID" then
			
			SpellFlashAddon.SetTimer(1, "WARLOCK.SetShardBagSize", nil, "InternalSpellFlashAddon", nil, SpellFlashAddon.WARLOCK.SetShardBagSize, 2)
			
	elseif event == "PLAYER_ENTERING_WORLD" then
			
			SpellFlashAddon.SetTimer(1, "WARLOCK.SetShardBagSize", nil, "InternalSpellFlashAddon", nil, SpellFlashAddon.WARLOCK.SetShardBagSize, 2)
			
	end

end




function SpellFlashAddon.isCurseOfShadow(unit)
	return SpellFlashAddon.checkDebuff(nil,unit,1,nil,nil,nil,nil,"Spell_Shadow_CurseOfAchimonde")
end

function SpellFlashAddon.isCurseOfTheElements(unit)
	return SpellFlashAddon.checkDebuff(nil,unit,1,nil,nil,nil,nil,"Spell_Shadow_ChillTouch")
end

function SpellFlashAddon.isCurseOfWeakness(unit)
	return SpellFlashAddon.checkDebuff(nil,unit,1,nil,nil,nil,nil,"Spell_Shadow_CurseOfMannoroth")
end

function SpellFlashAddon.isCurseOfRecklessness(unit)
	return SpellFlashAddon.checkDebuff(nil,unit,1,nil,nil,nil,nil,"Spell_Shadow_UnholyStrength")
end

function SpellFlashAddon.isCurseOfTongues(unit)
	return SpellFlashAddon.checkDebuff(nil,unit,1,nil,nil,nil,nil,"Spell_Shadow_CurseOfTounges")
end

function SpellFlashAddon.isCurseOfExhaustion(unit)
	return SpellFlashAddon.checkDebuff(nil,unit,1,nil,nil,nil,nil,"Spell_Shadow_GrimWard")
end

function SpellFlashAddon.isSiphonLife(unit)
	return SpellFlashAddon.checkDebuff(nil,unit,1,nil,nil,nil,nil,"Spell_Shadow_Requiem")
end

function SpellFlashAddon.isShadowburn(unit)
	return SpellFlashAddon.checkDebuff((GetSpellInfo(17877))--[["Shadowburn"]], unit)
end

function SpellFlashAddon.isFeared(unit)
	if
	SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,nil,"Spell_Shadow_Possession") --Fear
	or
	SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,nil,"Spell_Shadow_DeathScream") --Fear: Howl of Terror
	or
	SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,nil,"Spell_Shadow_PsychicScream") --Fear: Psychic Scream
	or
	SpellFlashAddon.checkDebuff(nil,unit,nil,nil,nil,nil,nil,"Ability_Druid_Cower") --Fear: Scare Beast
	then
		return true
	end
	return false
end







function SpellFlashAddon.Castable.Fear(SpellRank)
	if SpellFlashAddon.PRIEST then
		return castPsychicScream(SpellRank)
	elseif SpellFlashAddon.HUNTER then
		return castScareBeast(SpellRank)
	end
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(5782))--[["Fear"]]
	z.DebuffCheckIncluded = 1
	z.DebuffCheck = SpellFlashAddon.isCrowedControlled()
	local Name = UnitName("target")
	local timer = SpellFlashAddon.GetTimer(z.SpellName, Name, "InternalSpellFlashAddonSpellTimers")
	if timer > 0 and z.DebuffCheck then
		if timer <= 1.5 then
			if not SpellFlashAddon.isNoDamageCC() then
				z.DebuffCheck = nil
			end
		end
	end
	z.DebuffImmune = SpellFlashAddon.FearSpellCastImmune
	return SpellFlashAddon.CheckIfSpellCastable(z)
end





SpellFlashAddon.WARLOCK.ShardBagSize = 10
function SpellFlashAddon.WARLOCK.SetShardBagSize(show)
	if NUM_BAG_FRAMES and NUM_BAG_FRAMES > 0 then
		for bag=1,NUM_BAG_FRAMES do
			local bagslots = GetContainerNumSlots(bag)
			if bagslots and bagslots > 0 then
				local itemSubType = SpellFlashAddon.GetItemSubType(GetInventoryItemLink("player", ContainerIDToInventoryID(bag)))
				local SoulBag = (
					SpellFlashAddon.GetItemSubType(21340--[["Soul Pouch"]])
					or SpellFlashAddon.GetItemSubType(21341--[["Felcloth Bag"]])
					or SpellFlashAddon.GetItemSubType(21342--[["Core Felcloth Bag"]])
					or SpellFlashAddon.GetItemSubType(21872--[["Ebon Shadowbag"]])
					or SpellFlashAddon.GetItemSubType(22243--[["Small Soul Pouch"]])
					or SpellFlashAddon.GetItemSubType(22244--[["Box of Souls"]])
					or SpellFlashAddon.GetItemSubType(41597--[["Abyssal Bag"]])
				)
				if SoulBag and itemSubType == SoulBag then
					SpellFlashAddon.WARLOCK.ShardBagSize = bagslots
					SpellFlashAddon.debug("You have a "..itemSubType.." equipped in bag slot:  "..bag, show)
					return
				end
			end
		end
	end
	SpellFlashAddon.WARLOCK.ShardBagSize = 10
	SpellFlashAddon.debug("Soul Shard gather amount has been set to:  "..SpellFlashAddon.WARLOCK.ShardBagSize, show)
end



--This will return the numerical value of how many soul shards you have in your bags.
function SpellFlashAddon.WARLOCK.GiveSoulShardCount()
	return SpellFlashAddon.GiveContainerItemCount(nil,nil,6265)
end


function SpellFlashAddon.isCursed(unit)
	if
		SpellFlashAddon.checkDebuff((GetSpellInfo(980))--[["Curse of Agony"]],unit,1) or
		SpellFlashAddon.checkDebuff((GetSpellInfo(1714))--[["Curse of Tongues"]],unit,1) or
		SpellFlashAddon.checkDebuff((GetSpellInfo(1490))--[["Curse of the Elements"]],unit,1) or
		SpellFlashAddon.checkDebuff((GetSpellInfo(18223))--[["Curse of Exhaustion"]],unit,1) or
		SpellFlashAddon.checkDebuff((GetSpellInfo(702))--[["Curse of Weakness"]],unit,1) or
		SpellFlashAddon.checkDebuff((GetSpellInfo(603))--[["Curse of Doom"]],unit,1)
	then
		return true
	end
	return false
end




function SpellFlashAddon.isCurseOfAgony(unit)
	return SpellFlashAddon.checkDebuff((GetSpellInfo(980))--[["Curse of Agony"]],unit,1)
end

function SpellFlashAddon.isCurseOfDoom(unit)
	return SpellFlashAddon.checkDebuff((GetSpellInfo(603))--[["Curse of Doom"]],unit,1)
end

function SpellFlashAddon.isCorruption(unit)
	return SpellFlashAddon.checkDebuff((GetSpellInfo(172))--[["Corruption"]],unit,1)
end

function SpellFlashAddon.isImmolate(unit)
	return SpellFlashAddon.checkDebuff((GetSpellInfo(348))--[["Immolate"]],unit,1)
end

function SpellFlashAddon.isDemonArmorActive()
	return SpellFlashAddon.checkBuff((GetSpellInfo(706))--[["Demon Armor"]])
end






function SpellFlashAddon.Castable.Banish(SpellRank)
	if UnitCreatureType("target") ~= "Elemental" and UnitCreatureType("target") ~= "Demon" then
		return false
	end
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(710))--[["Banish"]]
	z.DebuffCheckIncluded = 1
	z.DebuffCheck = SpellFlashAddon.isNoDamageCC()
	local Name = UnitName("target")
	local timer = SpellFlashAddon.GetTimer(z.SpellName, Name, "InternalSpellFlashAddonSpellTimers")
	if timer > 0 and z.DebuffCheck then
		if timer < 1.5 then
			if not SpellFlashAddon.isBreakOnDamageCC() then
				z.DebuffCheck = nil
			end
		end
	end
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.DeathCoil(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(6789))--[["Death Coil"]]
	z.DebuffCheckIncluded = 1
	z.DebuffCheck = SpellFlashAddon.isCrowedControlled()
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.HowlOfTerror(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(5484))--[["Howl of Terror"]]
	z.EnemyTargetNotNeeded = 1
	z.NoRangeCheck = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


function SpellFlashAddon.Castable.DemonArmor()
	local z = {}
	z.SpellName = (GetSpellInfo(706))--[["Demon Armor"]]
	z.EnemyTargetNotNeeded = 1
	z.BuffName = z.SpellName
	if not SpellFlashAddon.Button[z.SpellName] then
		if not SpellFlashAddon.IsSpellKnown(z.SpellName) then
			z.SpellName = (GetSpellInfo(687))--[["Demon Skin"]]
			z.BuffName = z.SpellName
		else
			z.SpellCheckNotNeeded = 1
		end
	end
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


function SpellFlashAddon.Castable.CurseOfAgony(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(980))--[["Curse of Agony"]]
	z.DebuffName = z.SpellName
	return SpellFlashAddon.CheckIfSpellCastable(z)
end
castCoA = castCurseOfAgony

function SpellFlashAddon.Castable.Corruption(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(172))--[["Corruption"]]
	z.DebuffName = z.SpellName
	z.DebuffImmune = SpellFlashAddon.ShadowSpellCastImmune
	z.DebuffTimer = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.Immolate(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(348))--[["Immolate"]]
	z.DebuffName = z.SpellName
	z.DebuffImmune = SpellFlashAddon.FireSpellCastImmune
	z.DebuffTimer = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.SiphonLife(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(63108))--[["Siphon Life"]]
	z.DebuffName = z.SpellName
	z.DebuffImmune = SpellFlashAddon.DrainLifeSpellCastImmune or SpellFlashAddon.ShadowSpellCastImmune
	z.DebuffTimer = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.CurseOfDoom(SpellRank)
	if UnitPlayerControlled("target") then
		return false
	end
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(603))--[["Curse of Doom"]]
	z.DebuffImmune = SpellFlashAddon.CurseSpellCastImmune or SpellFlashAddon.CurseOfDoomSpellCastImmune or SpellFlashAddon.ShadowSpellCastImmune
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


function SpellFlashAddon.Castable.CurseOfTheElements(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(1490))--[["Curse of the Elements"]]
	z.DebuffName = z.SpellName
	z.DebuffImmune = SpellFlashAddon.CurseSpellCastImmune
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.CurseOfWeakness(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(702))--[["Curse of Weakness"]]
	z.DebuffName = z.SpellName
	z.DebuffImmune = SpellFlashAddon.CurseSpellCastImmune
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.CurseOfExhaustion(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(18223))--[["Curse of Exhaustion"]]
	z.DebuffName = z.SpellName
	z.DebuffImmune = SpellFlashAddon.CurseSpellCastImmune
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.CurseOfTongues(SpellRank)
	local z = {}
	z.SpellName = (GetSpellInfo(1714))--[["Curse of Tongues"]]
	z.Rank = SpellRank
	z.DebuffName = z.SpellName
	z.TargetThatUsesManaNeeded = 1
	z.DebuffImmune = SpellFlashAddon.CurseSpellCastImmune
	return SpellFlashAddon.CheckIfSpellCastable(z)
end



function SpellFlashAddon.Castable.DrainLife(SpellRank)
	local z = {}
	z.SpellName = (GetSpellInfo(689))--[["Drain Life"]]
	z.Rank = SpellRank
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.DrainMana(SpellRank)
	local z = {}
	z.SpellName = (GetSpellInfo(5138))--[["Drain Mana"]]
	z.Rank = SpellRank
	z.TargetThatUsesManaNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.Hellfire(SpellRank)
	local z = {}
	z.SpellName = (GetSpellInfo(1949))--[["Hellfire"]]
	z.Rank = SpellRank
	z.NoRangeCheck = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.RainOfFire(SpellRank)
	local z = {}
	z.SpellName = (GetSpellInfo(5740))--[["Rain of Fire"]]
	z.Rank = SpellRank
	z.NoRangeCheck = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end



function SpellFlashAddon.Castable.ShadowWard()
	local z = {}
	z.SpellName = (GetSpellInfo(6229))--[["Shadow Ward"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


function SpellFlashAddon.Castable.SoulFire(SpellRank, SkipShardCheck)
	local z = {}
	z.SpellName = (GetSpellInfo(6353))--[["Soul Fire"]]
	z.Rank = SpellRank
	if not SkipShardCheck then
		if z.Rank then
			if not SpellFlashAddon.Button[z.SpellName.."."..z.Rank] and not SpellFlashAddon.isItemByItemIDInContainer(6265) then
				return false
			end
		elseif not SpellFlashAddon.Button[z.SpellName] and not SpellFlashAddon.isItemByItemIDInContainer(6265) then
			return false
		end
	end
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


function SpellFlashAddon.Castable.DrainSoul()
end

function SpellFlashAddon.Castable.MaxDrainSoul(cycles)
	return castDrainSoul(cycles, "maximum")
end

function SpellFlashAddon.Castable.LowestDrainSoul(cycles)
	return castDrainSoul(cycles, "lowest")
end



function SpellFlashAddon.Castable.AutoTap()
	local c = SpellFlashAddon.inCombat()
	local m = UnitMana("player")
	local mm = UnitManaMax("player")
	local p = UnitMana("pet")
	local pm = UnitManaMax("pet")
	local h = UnitHealth("player")
	local hm = UnitHealthMax("player")
	local d = SpellFlashAddon.IsSpellKnown((GetSpellInfo(18220))--[["Dark Pact"]])
	local l = SpellFlashAddon.IsSpellKnown((GetSpellInfo(1454))--[["Life Tap"]])
	if not SpellFlashAddon.isCastingOrChanneling() and not (c and m / mm >= 0.9) then
		if d and mm - m >= 150 and (p == pm or (p / pm >= 0.99 and (h < hm or not l))) and castDarkPact() then
			return true
		elseif not (SpellFlashAddon.isEnemyTargetingYou() and c) and ((m / mm >= 0.8 and h / hm >= 0.98) or (m / mm < 0.8 and h / hm >= 0.95)) and castLifeTap() then
			return true
		end
	end
	return false
end



function SpellFlashAddon.Castable.DarkPactAndLifeTap(TapFirstPlayerHealthPercent, PactFirstPetManaPercent)
	local TapFirstPlayerHealthPercent = TapFirstPlayerHealthPercent or 97
	local PactFirstPetManaPercent = PactFirstPetManaPercent or 97
	if not SpellFlashAddon.IsSpellKnown((GetSpellInfo(18220))--[["Dark Pact"]]) then
		return castLifeTap()
	elseif not SpellFlashAddon.IsSpellKnown((GetSpellInfo(1454))--[["Life Tap"]]) then
		return castDarkPact()
	elseif SpellFlashAddon.HealthPercent("player") >= TapFirstPlayerHealthPercent and SpellFlashAddon.ManaPercent("pet") < PactFirstPetManaPercent and not (SpellFlashAddon.isEnemyTargetingYou() and SpellFlashAddon.inCombat()) and castLifeTap() then
		return true
	elseif castDarkPact() then
		return true
	end
	return castLifeTap()
end



function SpellFlashAddon.Castable.DarkPact()
end

function SpellFlashAddon.Castable.LifeTap()
end



function SpellFlashAddon.isNightfallActive()
	return SpellFlashAddon.checkBuff(nil,nil,nil,nil,nil,nil,nil,"Spell_Shadow_Twilight")
end






function SpellFlashAddon.Castable.ShadowBolt(SpellRank)
	local z = {}
	z.SpellName = (GetSpellInfo(686))--[["Shadow Bolt"]]
	z.Rank = SpellRank
	z.EvenIfCasting = isNightfallActive()
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.Shadowburn(SpellRank, SkipShardCheck, StopCast)
	local z = {}
	z.SpellName = (GetSpellInfo(17877))--[["Shadowburn"]]
	z.Rank = SpellRank
	z.EvenIfCasting = StopCast
	if not SkipShardCheck then
		if z.Rank then
			if not SpellFlashAddon.Button[z.SpellName.."."..z.Rank] and not SpellFlashAddon.isItemByItemIDInContainer(6265) then
				return false
			end
		elseif not SpellFlashAddon.Button[z.SpellName] and not SpellFlashAddon.isItemByItemIDInContainer(6265) then
			return false
		end
	end
	return SpellFlashAddon.CheckIfSpellCastable(z)
end



function SpellFlashAddon.Castable.SearingPain(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(5676))--[["Searing Pain"]]
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

function SpellFlashAddon.Castable.FelDomination()
	local z = {}
	z.SpellName = (GetSpellInfo(18708))--[["Fel Domination"]]
	z.EnemyTargetNotNeeded = 1
	return SpellFlashAddon.CheckIfSpellCastable(z)
end


function SpellFlashAddon.Castable.Conflagrate(SpellRank)
	local z = {}
	z.Rank = SpellRank
	z.SpellName = (GetSpellInfo(17962))--[["Conflagrate"]]
	if not z.SpellName and not SpellFlashAddon.isImmolate() then
		return false
	end
	return SpellFlashAddon.CheckIfSpellCastable(z)
end

--This will return true if it is a good time to drain your target's soul
function SpellFlashAddon.ShouldDrainSoul(MaxShards)
	if SpellFlashAddon.isDieingEnemy() and SpellFlashAddon.GivesXP() and not SpellFlashAddon.isShadowburn() and SpellFlashAddon.WARLOCK.GiveSoulShardCount() < (MaxShards or SpellFlashAddon.WARLOCK.ShardBagSize) then
		return true
	end
	return false
end






